VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cls_CDraw"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

'################################################################################
'
' Draw Klasse zum zeichnen von Diagramme aus Chart Klasse auf Verschidene Objekte
'
'################################################################################

'GDI Deklarationen
      Private Declare Function GetPixel Lib "gdi32" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long) As Long
      Private Declare Function Polyline Lib "gdi32" (ByVal hdc As Long, lpPoint As POINTAPI, ByVal nCount As Long) As Long
      Private Declare Function MoveToEx Lib "gdi32" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long, lpPoint As POINTAPI) As Long
      Private Declare Function LineTo Lib "gdi32" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long) As Long
      Private Declare Function SelectObject Lib "gdi32" (ByVal hdc As Long, ByVal hObject As Long) As Long
      Private Declare Function TextOut Lib "gdi32" Alias "TextOutA" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long, ByVal lpString As String, ByVal nCount As Long) As Long
      Private Declare Function CreateFont Lib "gdi32" Alias "CreateFontA" (ByVal h As Long, ByVal w As Long, ByVal E As Long, ByVal o As Long, ByVal w As Long, ByVal i As Long, ByVal u As Long, ByVal s As Long, ByVal c As Long, ByVal OP As Long, ByVal CP As Long, ByVal Q As Long, ByVal PAF As Long, ByVal F As String) As Long
      Private Declare Function CreatePen Lib "gdi32" (ByVal nPenStyle As Long, ByVal nWidth As Long, ByVal crColor As Long) As Long
      Private Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
      'Public Declare Function PolylineTo Lib "gdi32.dll" (ByVal hdc As Long, lppt As POINTAPI, ByVal cCount As Long) As Long
      Private Declare Function GetDeviceCaps Lib "gdi32" (ByVal hdc As Long, ByVal nIndex As Long) As Long
      Private Declare Function SetTextColor Lib "gdi32" (ByVal hdc As Long, ByVal crColor As Long) As Long
      Private Declare Function CreateFontIndirect Lib "gdi32" Alias "CreateFontIndirectA" (lpLogFont As LOGFONT) As Long
      Private Declare Function DrawText Lib "user32" Alias "DrawTextA" (ByVal hdc As Long, ByVal lpStr As String, ByVal nCount As Long, lpRect As RECT, ByVal wFormat As Long) As Long
      Private Declare Function CreateSolidBrush Lib "gdi32" (ByVal crColor As Long) As Long
      Private Declare Function ExtFloodFill Lib "gdi32" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long, ByVal crColor As Long, ByVal wFillType As Long) As Long
      Private Declare Function Rectangle Lib "gdi32" (ByVal hdc As Long, ByVal x1 As Long, ByVal y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Long
      Private Declare Function GetCursorPos Lib "user32" (lpPoint As POINTAPI) As Long

      Private Const FLOODFILLSURFACE = 1

      Private Const DT_LEFT = &H0
      Private Const DT_VCENTER = &H4
      Private Const DT_SINGLELINE = &H20

'Konstanten (fr GetDeviceCaps)
      Private Const LOGPIXELSX = 88
      Private Const LOGPIXELSY = 90
      Private Const PHYSICALWIDTH = 110
      Private Const PHYSICALHEIGHT = 111
      Private Const PHYSICALOFFSETX = 112
      Private Const PHYSICALOFFSETY = 113

'Struktur Deklarationen
      Private Type POINTAPI
          X As Long
          Y As Long
      End Type
      
      Private Type RECT
          Left As Long
          Top As Long
          Right As Long
          Bottom As Long
      End Type
  
      Private Type CWPSTRUCT
        lParam As Long
        wParam As Long
        message As Long
        hWnd As Long
      End Type
 
      Private Const LF_FACESIZE = 32
      Private Const FONT_SITZ = 8
      Private Type LOGFONT
              lfHeight As Long
              lfWidth As Long
              lfEscapement As Long
              lfOrientation As Long
              lfWeight As Long
              lfItalic As Byte
              lfUnderline As Byte
              lfStrikeOut As Byte
              lfCharSet As Byte
              lfOutPrecision As Byte
              lfClipPrecision As Byte
              lfQuality As Byte
              lfPitchAndFamily As Byte
              lfFaceName As String * LF_FACESIZE 'lfFaceName(1 To LF_FACESIZE) As Byte
      End Type
      
'Zufallsfarbe
      Public Enum aRGB
          RNDhell = 0
          rtlich
          blulich
          grnlich
          gelb
          rot
          grn
          blau
          dunkelrot
          End Enum

      
'Default Eigenschaften
    'Private Const cYNull = -100000 ' Y nicht sichtbarer Bereich ('siehe mod_help)

'##################   Public Eigenschaften  #######################
      Public lDLColor As Long 'Default Linien Farbe

'##################   Private Eigenschaften  #######################

      Private MPoint As POINTAPI 'GetCursorPos
      Private yxLegend As POINTAPI 'Move Legende
      Private LineIndex As Integer
      
      Private Chart As frm_CHART 'Object 'ActiveChart
      Private phdc As Long
      Private pPrint As Boolean
      Private pFOffs As Double 'Font Ausrichtung
      
'Grenwerte Hhen & Breite des Chart
      Private pHeight As Long
      Private pWidth As Long
      
'Linien Strke
      Private pLPixel As Long
      Private pHPixel As Long

      Private pFSize As Long

'Chart Rnder#
      Private pCLRand As Integer   'Links
      Private pCRRand As Integer   'Rechts
      Private pCORand As Integer   'Oben
      Private pCURand As Integer   'Unten
      
'##################  Public Chart Sub | Function  ###################################

'Move Legende
  Public Sub LegendeDrag()
          With Chart
          GetCursorPos MPoint
          yxLegend.X = .lbLegend.Left - PixelToTwipsX((MPoint.X))
          yxLegend.Y = .lbLegend.Top - PixelToTwipsY((MPoint.Y))
          .lbLegend.Drag vbBeginDrag
          .lbLegend.VISIBLE = False
          End With
  End Sub
  Public Sub LegendeDrop()
          With Chart
          GetCursorPos MPoint
          .lbLegend.Drag vbCancel
          .lbLegend.Left = yxLegend.X + PixelToTwipsX((MPoint.X))
          .lbLegend.Top = yxLegend.Y + PixelToTwipsY((MPoint.Y))
          .lbLegend.VISIBLE = True
          End With
    End Sub

'Line zu Lines hinzufgen
      Public Function LineAdd(fDatum, fZeitR, Filname$)
          Dim cLine As cls_Line
          LineIndex = LineIndex + 1
          Set cLine = New cls_Line
          With cLine    'Initialisierung
              .QUELLE = Filname$
              .DATUM = fDatum
              .addValue = fZeitR
              .Color = IIf(LineIndex = 1, lDLColor, Get_RGB(aRGB.RNDhell))
              .LKEY = "cLine" & CStr(LineIndex)
              Chart.Lines.Add Item:=cLine, Key:=.LKEY
          End With
          Set cLine = Nothing
          ACRefresh
          End Function
          
'Chart Refresh
      Public Sub ACRefresh()
          Chart.ChartRefresh
          End Sub

'Line von Lines entfernen
      Public Function LineDrop(Optional LKEY)
          On Error Resume Next
          Dim cLine As cls_Line
          If IsMissing(LKEY) Then
            For Each cLine In Chart.Lines
              Chart.Lines.Remove (1)
            Next
            LineIndex = 0
          Else
            Chart.Lines.Remove (LKEY)
          End If
          ACRefresh
          End Function
        
'ActiveChart
      Public Sub ACSet(oChart As frm_CHART, ByRef lHeight As Long, ByRef lWidth As Long)
          On Error Resume Next
          Set Chart = oChart
          With Chart
          phdc = .hdc
          pHeight = .lHeight
          pWidth = .lWidth
          pFSize = .lCht_FSize   'Fontgre
          End With
          ACIniziale
      End Sub
      
'ChartPrint
      Public Sub ACPrint(ByVal dc As Long)
          Dim lHeight As Long, lWidth As Long, hdc As Long, FSize As Long
          'Backup Sets
          lHeight = pHeight: lWidth = pWidth: hdc = phdc: FSize = pFSize
          pHeight = GetDeviceCaps(dc, PHYSICALHEIGHT) - GetDeviceCaps(dc, PHYSICALOFFSETY) * 2
          pWidth = GetDeviceCaps(dc, PHYSICALWIDTH) - GetDeviceCaps(dc, PHYSICALOFFSETX) * 2
          phdc = dc
          ACIniziale 1
          ACDraw
          ACIniziale
          'Restore Sets
          pHeight = lHeight: pWidth = lWidth: phdc = hdc: pFSize = FSize
          End Sub

'ChartIniziale
      Public Sub ACIniziale(Optional sPrint)
            If IsMissing(sPrint) Then
                pCLRand = 50
                pCRRand = 20
                pCORand = 20
                pCURand = 30
                pLPixel = 1       'LinePunktgre
                pHPixel = 0
                pFOffs = 1.7
                pPrint = False
            Else 'zum Drucken
                pCLRand = 1050
                pCRRand = 250
                pCORand = 650
                pCURand = 250
                pFSize = 80
                pLPixel = 7
                pHPixel = 2
                pPrint = True
                pFOffs = 1.35
            End If
err:
          End Sub
     
'Chart X/Y Legende & Lines zeichnen
      Public Sub ACDraw()
        Dim i&, retVal, col&, s$, p, c, c1
        Dim Line As cls_Line
        Dim LVal As Long, j%
        Dim sDatum  As Date
        Dim picRECT As RECT
        Dim aPoint(2)  As POINTAPI, pPoly() As POINTAPI
        Dim iStep As Integer
        Dim iColMax As Integer
        Dim iXCount As Integer
        Dim lXValue() As Long
        Dim dCXFact As Double, dCYFact As Double

        Dim iColMin As Integer

        Dim lCYRand As Long

          On Error Resume Next
          With Chart

    'Spalten Automatik
              If ACColAuto Then ACRefresh: Exit Sub
    
              lCYRand = CYRand
              iColMin% = .iCht_XMinValOffs

    'Chart Berechnungs Faktoren
              dCYFact = YFact
              dCXFact = XFact
              
    'X-Werte POINTAPI
              Dim iP%
              'iP% = 1
              iP% = .lCht_MWXBeginn
              
'              iXCount = XMaxVal
'              ReDim pPoly(iXCount + iP%)
'              For i = iP% To iXCount + iP%
'                pPoly(i - iP%).x = pCLRand + dCXFact * i
'              Next
              iXCount = XMaxVal + iP%
              ReDim pPoly(iXCount)
              For i = 0 To iXCount
                pPoly(i).X = pCLRand + dCXFact * i
              Next
              'If iP% = 1 Then pPoly(0).x = pPoly(1).x - dCXFact
              
    'Meswertanzeige
              .lCht_MWXMin = (pPoly(0).X)
              .lCht_MWXBereich = (pPoly(iXCount).X) - .lCht_MWXMin
              .lCht_MWXCount = iXCount

              
    'Y-Legende & H-Linien
              Font , phdc, pFSize
              Stift , phdc, RGB(80, 80, 80), 0, pHPixel
              
                  aPoint(0).X = pCLRand - 5 + pWidth / 96      'H-Legende Linien Lnge
                  aPoint(1).X = pWidth - pCRRand '+ dCXFact * iP%
                  iStep = IIf(pHeight < 200, 2, 1)
                  For i = 0 To YMaxVal - YMaxVal Mod CYInt Step CYInt * iStep%
                      aPoint(0).Y = lCYRand - (dCYFact * i)
                      aPoint(1).Y = aPoint(0).Y
                      retVal = Polyline(phdc, aPoint(0), 2)
                      s$ = Format(i, "&&&&&&")
                      retVal = TextOut(phdc, pCLRand - 38 + (6 - Len(s$)) * 6, _
                                        aPoint(0).Y - pFSize / 2, s$, Len(s$))
                  Next
              
    'Y-Legende Bezeichnung
                  s$ = .sCht_YLName
                  retVal = TextOut(phdc, pCLRand - 45 + (6 - Len(s$)) * 6, _
                                    aPoint(0).Y + pFSize / 5, s$, Len(s$))
   
    'X-Legende & V-Linien
              Stift 1, phdc, RGB(80, 80, 80), 2, pHPixel
                  aPoint(0).Y = pHeight - pFSize * 2  'V-Linien Lnge
                  aPoint(1).Y = pCORand
                  iStep = (iXCount + 1) / 24
                  For i = iStep - 1 To iXCount - iStep Step iStep
                      aPoint(0).X = pPoly(i + iP%).X
                      aPoint(1).X = pPoly(i + iP%).X
                      retVal = Polyline(phdc, aPoint(0), 2)
                      s$ = Format(((i + 1 + iColMin%) / 4 Mod 24), " 00") '1,7
                      retVal = TextOut(phdc, aPoint(0).X - pFSize / pFOffs, aPoint(0).Y, s$, Len(s$))
                  Next
                      aPoint(0).X = pPoly(i).X
                      aPoint(1).X = pPoly(i).X
                      retVal = Polyline(phdc, aPoint(0), 2)
                      s$ = .sCht_XLName
                      retVal = TextOut(phdc, aPoint(0).X - pFSize / pFOffs, aPoint(0).Y, s$, Len(s$))
              Stift 1
              Font 1

'Titel zeichnen ###################################################################################################################

              If pPrint Then
                    Font , phdc, pFSize * 3, RGB(50, 50, 120)
                      aPoint(0).X = pFSize '.b / 3
                      aPoint(0).Y = pCRRand / 2
                      s$ = .sCht_Titel
                      retVal = TextOut(phdc, aPoint(0).X, aPoint(0).Y, s$, Len(s$))
                    Font 1
              End If
              
'Datums Trennlinie ###################################################################################################################
              
              Stift , phdc, RGB(150, 150, 230), 0, 0
              Font , phdc, pFSize, RGB(150, 150, 230)
                'V-Linien Lnge
                aPoint(0).Y = pHeight - pFSize * 1
                aPoint(1).Y = pCORand
                'iColMax = iColMin% Mod 96
                'For i = 95 - (iColMin% Mod 96) To iXCount - iP% * 2 - (iColMin% Mod 96) Step 96
                For i = 95 - ((iColMin% - iP%) Mod 96) To iXCount - ((iColMin% - iP%) Mod 96) Step 96
                    aPoint(0).X = pPoly(i).X
                    aPoint(1).X = pPoly(i).X
                    retVal = Polyline(phdc, aPoint(0), 2)
                Next

'Datum Bezeichnung ##################################################################################################################
             If Chart.bHDatum Then
                For Each Line In .Lines
                  If sDatum = "00:00:00" Then sDatum = Line.DATUM
                Next
                If sDatum <> "00:00:00" Then
                    sDatum = sDatum + iColMin% / 96
                    iStep = IIf(iXCount > 1440, 192, 96)
                    For i = -1 + iP% To iXCount Step iStep
                          j = i - (iColMin% Mod 96)
                          If j >= -1 And j <> iXCount Then
                              iColMax = pCLRand + (pWidth - pCLRand - pCRRand) / XMaxVal * (j)
                              s$ = Format(sDatum, "|Ddd dd.mm")
                              retVal = TextOut(phdc, iColMax - pFSize / pFOffs / 10, pHeight - pFSize, s$, Len(s$))
                              retVal = TextOut(phdc, iColMax - pFSize / pFOffs / 10, pCORand - pFSize * 1.5, s$, Len(s$))
                          
            'Feiertage ######################################
                              On Error GoTo errFDay
                              If IsFeierTagY(sDatum, 1, s$) Then
                                  Font 1, phdc, -pFSize, RGB(230, 0, 0)
                                    picRECT.Left = iColMax
                                    picRECT.Top = 1
                                    picRECT.Right = picRECT.Left + 100
                                    picRECT.Bottom = picRECT.Top + 260 'Len(s$) * 15
                                    retVal = DrawText(phdc, s$, Len(s$), picRECT, DT_LEFT Or DT_VCENTER Or DT_SINGLELINE)
                                  Font 1, phdc, pFSize, RGB(150, 150, 230)
                              End If
                          End If
errFDay:                  sDatum = sDatum + 1
                      Next
                  End If
                End If
                Font 1
                Stift 1

'Legende ###################################################################################################################
      'If Chart.bLegende Then
      If Not pPrint Then
              Chart.lbLegend.Cls
              i = 1
              For Each Line In .Lines
                With Line
                    Stift , phdc, .Color, 0, pLPixel
                    s$ = .QUELLE
                    col& = .Color
                    With Chart
                        .lbLegend.FontSize = 11
                        .lbLegend.FontBold = True
                        .lbLegend.ForeColor = col&
                        '.lbLegend.Height = PixelToTwipsY(17 * (Copt.LG_index% + 2))
                        .lbLegend.Height = PixelToTwipsY(17 * (i + 2))
                        .lbLegend.Width = IIf(.lbLegend.Width < Len(s$) * 125, Len(s$) * 125, .lbLegend.Width)
                        picRECT.Left = 18  'xPosition
                        'picRECT.Top = 17 * Copt.LG_index% 'yPosition
                        picRECT.Top = 17 * i 'yPosition
                        picRECT.Right = picRECT.Left + 700 'Len
                        picRECT.Bottom = picRECT.Top + 17
                        retVal = DrawText(.lbLegend.hdc, s$, Len(s$), picRECT, DT_LEFT Or DT_VCENTER Or DT_SINGLELINE)
                        .lbLegend.DrawWidth = 2
                        retVal = Rectangle(.lbLegend.hdc, 5, picRECT.Top + 4, 14, picRECT.Top + 13)
                        .lbLegend.ForeColor = &H80000000 'ChartLines.MpColor
                        .lbLegend.DrawWidth = 3
                        retVal = Rectangle(.lbLegend.hdc, 7, picRECT.Top + 6, 11, picRECT.Top + 10)
                        'retVal = RoundRect(.lbLegend.hdc, 5, picRECT.Top + 3, 15, picRECT.Top + 13, 5, 5)
                        i = i + 1
                    End With
                    Stift 1
                End With
              Next
        Else
              i = 1
              Font , phdc, pFSize, RGB(50, 50, 120)
              For Each Line In .Lines
                With Line
                    Stift , phdc, .Color, 0, pLPixel * 5
                    s$ = .QUELLE
                            aPoint(0).X = pFSize * 1.5
                            aPoint(0).Y = pCORand + pFSize * i
                            retVal = TextOut(phdc, aPoint(0).X + pFSize, aPoint(0).Y - pFSize / 2, s$, Len(s$))
                            aPoint(1) = aPoint(0)
                            retVal = Polyline(phdc, aPoint(0), 2)
                        i = i + 1
                    Stift 1
                End With
              Next
              Font 1
        End If
        'End If
'Linien zeichnen ###################################################################################################################

              For Each Line In .Lines
                With Line
                    Stift , phdc, .Color, 0, pLPixel
                    iColMax = IIf(UBound(pPoly) + iColMin% > .ValCount, .ValCount, UBound(pPoly) + iColMin%)
                    i = iColMin%
                    For i = iColMin% To iColMax
                          'leere Werte berspringen, nchst gltigen suchen
                          If .Value(i) <> cYNull Then
                              p = i - iColMin%
                              'Werte in POINTAPI bernehmen, bei ungltigen Werten abbrechen
                              For j = i To iColMax
                                  LVal = .Value(j)
                                  If LVal = cYNull Then pPoly(j - iColMin%).Y = cYNull: Exit For
                                  pPoly(j - iColMin%).Y = lCYRand - dCYFact * CLng(LVal)
                              Next
                              i = j
                              'bisherige Werte zeichnen
                              retVal = MoveToEx(phdc, pPoly(p).X, pPoly(p).Y, aPoint(2))
                              retVal = Polyline(phdc, pPoly(p), i - p - iColMin%)
                           Else
                           pPoly(i - iColMin%).Y = cYNull
                           End If
                    Next 'loop bis YWerteende erreicht
                    Stift 1
    'Punkte zeichnen
                    If .MPunkte Or Chart.bMPunkte Then
                        Stift , phdc, RGB(0, 0, 0), 0, 4
                            For i = iColMin% To iColMax
                                aPoint(0) = pPoly(i - iColMin%)
                                aPoint(1) = pPoly(i - iColMin%)
                                retVal = Polyline(phdc, aPoint(0), 2)
                            Next
                        Stift 1, phdc, .Color, 0, 3
                            For i = iColMin% To iColMax
                                aPoint(0) = pPoly(i - iColMin%)
                                aPoint(1) = pPoly(i - iColMin%)
                                retVal = Polyline(phdc, aPoint(0), 2)
                            Next
                        Stift 1
                    End If
                End With
              Next
              
err:      End With
          err.Number = 0
          End Sub

          
'Spalten Automatik Public fr MDI Steuerung
      Public Function ACColAuto() As Boolean
          Dim Line As cls_Line, iColMax As Integer
          With Chart
              For Each Line In .Lines 'Max Spalten ermitteln
                iColMax = IIf(Line.ValCount > iColMax, Line.ValCount, iColMax)
              Next
              If .iCht_XMaxValVirtuel <> iColMax Then
                .iCht_XMaxValVirtuel = iColMax
                .iCht_XMaxVal = iColMax
                ACColAuto = True
                Exit Function
              End If
              If .iCht_XMaxValScroll <> .iCht_XMaxValVirtuel - .iCht_XMaxVal Then
                  .iCht_XMaxValScroll = .iCht_XMaxValVirtuel - .iCht_XMaxVal
              End If
          End With
          End Function
          
'##################   Private Property Eigenschaften  #######################

'Chart Y Rand
      Private Property Get CYRand() As Long
          With Chart
              CYRand = pHeight - pCURand
          End With
          End Property
          
'Chart X Berechnungs Faktoren
      Private Property Get XFact() As Double
          With Chart
              XFact = (pWidth - pCRRand - pCLRand) / XMaxVal
          End With
          End Property

'Chart Y Berechnungs Faktoren
      Private Property Get YFact() As Double
          With Chart
              YFact = (pHeight - pCORand - pCURand) / YMaxVal
          End With
          End Property
          
'X-Legende Max Mindest Werte
      Private Property Get XMaxVal() As Long
          With Chart
            XMaxVal = IIf(.iCht_XMaxVal > 95, .iCht_XMaxVal, 95)
          End With
          End Property
          
'Y-Legende Max Mindest Werte
      Private Property Get YMaxVal() As Long
          With Chart
              .lCht_YMaxVal = IIf(.lCht_YMaxVal < 500, 500, .lCht_YMaxVal)
              .lCht_YMaxVal = IIf(.lCht_YMaxVal > 300000, 300000, .lCht_YMaxVal)
              YMaxVal = .lCht_YMaxVal
          End With
          End Property
          
'Aufteilung fr Hilfslinien
'Y-Legende Intervall
      Private Property Get CYInt() As Long
              Dim c, c1
              c = YMaxVal / 10: c1 = val(Left(Trim(Str(c)), 1))
              Select Case c1
              Case 3 To 4: c1 = 2.5
              Case Is >= 5: c1 = 5
              End Select
              CYInt = CLng(c1 * val(Replace("1" & Space(Len(Str(c)) - 2), " ", "0")))
          End Property


'##################  Public Sub | Function  ##################################
 
'Twips in Pixel umrechnen
      Public Function TwipsToPixelX(Twips&) As Long ' Integer
          TwipsToPixelX = CLng(Twips& / Screen.TwipsPerPixelX)
          End Function
      Public Function TwipsToPixelY(Twips&) As Long 'Integer
          TwipsToPixelY = CLng(Twips& / Screen.TwipsPerPixelY)
          End Function
          
'Pixel in Twips umrechnen
      Public Function PixelToTwipsY(Pixel%) As Long
          PixelToTwipsY = Screen.TwipsPerPixelY * Pixel%
          End Function
      Public Function PixelToTwipsX(Pixel%) As Long
          PixelToTwipsX = Screen.TwipsPerPixelX * Pixel%
          End Function

'Zeit in Spalte wandeln  (00:00 - 23:45 = 0 - 95)
      Public Function ZeitToCol(ic%, ByVal Zeit$) As Boolean
          On Error Resume Next
          ZeitToCol = False
              Zeit$ = Format(Zeit$, "hh:mm")
              ic% = CByte(Left(Zeit$, 2)) * 4 + Fix(CByte(Right(Zeit$, 2)) / 15)
              'If ic% = 0 Then ic% = 96
          If err.Number = 0 Then ZeitToCol = True
          End Function

'##################  Private Sub | Function  ##################################

'Stift erstellen/lschen
      Private Function Stift(Optional del, Optional phdc, Optional crColor&, Optional nPenStyle&, Optional nWidth&)
          Static pen&
          If Not IsMissing(del) Then DeleteObject pen&
          If Not IsMissing(phdc) Then pen& = CreatePen(nPenStyle&, nWidth& + 1, crColor&): SelectObject phdc, pen&
          End Function
          
'Font erstellen/lschen
      Private Function Font(Optional del, Optional phdc, Optional FSize&, Optional Color)
          Static fnt&: Dim col&, retVal&
          If Not IsMissing(del) Then DeleteObject fnt&
          If Not IsMissing(phdc) Then
              If FSize& > 0 Then
                fnt& = CreateFont(FSize&, 0, 0, 0, 400, 0, 0, 0, 0, 0, 0, 0, 0, "Arial")
                SelectObject phdc, fnt&
              Else
                  'Ausgabe 90 Grad
                  'FontDeclaration
                  Dim MY_Font As LOGFONT
                  Dim prevFont As Long
                  MY_Font.lfFaceName = "Arial" + Chr$(0)
                  MY_Font.lfEscapement = 900 ' Grad
                  MY_Font.lfHeight = (FONT_SITZ * -20) / Screen.TwipsPerPixelY
                  fnt& = CreateFontIndirect(MY_Font)
                  SelectObject phdc, fnt&
              End If
          End If
          If Not IsMissing(Color) Then col& = Color Else col& = 0
          If Not IsMissing(phdc) Then retVal = SetTextColor(phdc, col&)
          End Function
 
'Zufallsfarbe
    Private Function Get_RGB(aRGB) As Long
                    Select Case aRGB
                        Case 0: Get_RGB = RGB(240 * Rnd, 240 * Rnd, 240 * Rnd) 'hell
                        Case 1: Get_RGB = RGB(256, 50 * Rnd, 50 * Rnd) 'rtlich
                        Case 2: Get_RGB = RGB(50 * Rnd, 200 * Rnd, 50 * Rnd) 'blulich
                        Case 3: Get_RGB = RGB(50 * Rnd, 50 * Rnd, 200 * Rnd) 'grnlich
                        Case 4: Get_RGB = RGB(256, 256, 0) 'gelb
                        Case 5: Get_RGB = RGB(256, 0, 0) 'rot
                        Case 6: Get_RGB = RGB(0, 200, 0) 'grn
                        Case 7: Get_RGB = RGB(100, 50, 250) 'blau
                        Case 8: Get_RGB = RGB(250, 0, 80) 'drot
                    End Select
                    End Function

