Attribute VB_Name = "mod_FDay"
Option Explicit

'Feiertage
Public FeiertageName
Public Const c_FTag_Karlfreitag = -2
Public Const c_FTag_Ostersonntag = 0
Public Const c_FTag_Ostermontag = 1
Public Const c_FTag_Pfingsten = 50
Public Const c_FTag_Himmelfahrt = 39
Public Const c_FTag_Fest = 99


'Datum auf Feiertag prfen
    Public Function IsFeierTagY(ByVal aDate As Date, Optional Variabel, Optional Name) As Boolean
        Static sOSTERN As Date, SomZeit$, WinZeit$, LastYear%, TempDate As Date
        If LastYear% <> Year(aDate) Then
            LastYear% = Year(aDate)
            sOSTERN = OSTERN(Format(aDate, "yyyy"))
            TempDate = "31.03." & Year(aDate):  Do Until Weekday(TempDate) = 1: TempDate = TempDate - 1: Loop: SomZeit$ = Format(TempDate, "dd.mm")
            TempDate = "31.10." & Year(aDate):  Do Until Weekday(TempDate) = 1: TempDate = TempDate - 1: Loop: WinZeit$ = Format(TempDate, "dd.mm")
        End If
        IsFeierTagY = True
        'Bewegliche Feiertage
        Select Case Format(aDate, "dd.mm.yy")
            Case sOSTERN + c_FTag_Karlfreitag
                If Not IsMissing(Variabel) Then Variabel = c_FTag_Karlfreitag: Name = " <Karlfreitag> "
                Exit Function
            Case sOSTERN + c_FTag_Ostersonntag
                If Not IsMissing(Variabel) Then Variabel = c_FTag_Ostersonntag: Name = " <Ostersonntag> "
                Exit Function
            Case sOSTERN + c_FTag_Ostermontag
                If Not IsMissing(Variabel) Then Variabel = c_FTag_Ostermontag: Name = " <Ostermontag> "
                Exit Function
            Case sOSTERN + c_FTag_Pfingsten
                If Not IsMissing(Variabel) Then Variabel = c_FTag_Pfingsten: Name = " <Pfingsten> "
                Exit Function
            Case sOSTERN + c_FTag_Himmelfahrt
                If Not IsMissing(Variabel) Then Variabel = c_FTag_Himmelfahrt: Name = " <Himmelfahrt> "
                Exit Function
        End Select
        'Feste Feiertage
        Select Case Format(aDate, "dd.mm")
            Case "01.01": If Not IsMissing(Variabel) Then Variabel = c_FTag_Fest: Name = " <Neujahr> ": Exit Function
            Case "01.05": If Not IsMissing(Variabel) Then Variabel = c_FTag_Fest: Name = " <1.Mai> ": Exit Function
            Case "03.10": If Not IsMissing(Variabel) Then Variabel = c_FTag_Fest: Name = " <3.Oktober> ": Exit Function
            Case "31.10": If Not IsMissing(Variabel) Then Variabel = c_FTag_Fest: Name = " <31.Oktober> ": Exit Function
            Case "25.12": If Not IsMissing(Variabel) Then Variabel = c_FTag_Fest: Name = " <Weinachten> ": Exit Function
            Case "26.12": If Not IsMissing(Variabel) Then Variabel = c_FTag_Fest: Name = " <Weinachten> ": Exit Function
            Case SomZeit: If Not IsMissing(Variabel) Then Variabel = c_FTag_Fest: Name = " <Sommer Zeitumstellung> ": Exit Function
            Case WinZeit: If Not IsMissing(Variabel) Then Variabel = c_FTag_Fest: Name = " <Winter Zeitumstellung> ": Exit Function
        End Select
        IsFeierTagY = False
        End Function

'Ostern berechnen
      Public Function OSTERN(Jahr As Integer)
          Dim ZR1%, ZR2%, ZR3%, ZR4%, ZR5%, ZR6%, ZR7%
          ZR1 = Jahr Mod 19 + 1
          ZR2 = Fix(Jahr / 100) + 1
          ZR3 = Fix(3 * ZR2 / 4) - 12
          ZR4 = Fix((8 * ZR2 + 5) / 25) - 5
          ZR5 = Fix(5 * Jahr / 4) - ZR3 - 10
          ZR6 = (11 * ZR1 + 20 + ZR4 - ZR3) Mod 30
          If (ZR6 = 25 And ZR1 > 11) Or ZR6 = 24 Then ZR6 = ZR6 + 1
          ZR7 = 44 - ZR6
          If ZR7 < 21 Then ZR7 = ZR7 + 30
            ZR7 = ZR7 + 7
          ZR7 = ZR7 - (ZR5 + ZR7) Mod 7
          If ZR7 <= 31 Then
            OSTERN = DateSerial(Jahr, 3, ZR7)
          Else
            OSTERN = DateSerial(Jahr, 4, ZR7 - 31)
          End If
          End Function

'Datums Functionen
'      Public Function YearInc(ByVal inDate As Date) As Date
'          YearInc = Day(inDate) & "." & Month(inDate) & "." & Year(inDate) + 1
'          End Function
'      Public Function YearDec(ByVal inDate As Date) As Date
'          YearDec = Day(inDate) & "." & Month(inDate) & "." & Year(inDate) - 1
'          End Function
'      Public Function MonthInc(ByVal inDate As Date) As Date
'          MonthInc = "15." & Month(inDate) & "." & Year(inDate)
'          MonthInc = MonthInc + 60: MonthInc = "01." & Month(MonthInc) & "." & Year(MonthInc)
'          MonthInc = MonthInc - 1
'          MonthInc = Day(inDate) & "." & Month(MonthInc) & "." & Year(inDate)
'          End Function
'      Public Function MonthDec(ByVal inDate As Date) As Date
'          MonthDec = "15." & Month(inDate) & "." & Year(inDate)
'          MonthDec = MonthDec - 30: MonthDec = "01." & Month(MonthDec) & "." & Year(MonthDec)
'          MonthDec = Day(inDate) & "." & Month(MonthDec) & "." & Year(inDate)
'          End Function
