Attribute VB_Name = "mod_ini"
Option Explicit

' API's fr Lesen/und Schreiben von INI-Dateien
      Private Declare Function GetPrivateProfileString Lib "KERNEL32" Alias "GetPrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long
      Private Declare Function WritePrivateProfileString Lib "KERNEL32" Alias "WritePrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpString As Any, ByVal lpFileName As String) As Long
      'Private Declare Function WritePrivateProfileSection Lib "kernel32" Alias "WritePrivateProfileSectionA" (ByVal lpAppName As String, ByVal lpString As String, ByVal lpFileName As String) As Long
      'Private Declare Function GetPrivateProfileSection Lib "kernel32" Alias "GetPrivateProfileSectionA" (ByVal lpAppName As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long
      'Private Declare Function API_GetUserName Lib "advapi32.dll" Alias "GetUserNameA" (ByVal lpBuffer As String, nSize As Long) As Long

'INI Modul variablen
      Private INIFileName As String
      Private fOpt As frm_OPT
      Private Const cTrenn = ","
      Private Const cMsgIniErr = "Die Ini-Datei ist fehlerhaft und wird neu Erstellt!"
      Private Const cMsgIniSet = "Einstellungen werden erst beim nchsten Programmstart bernommen!"
      
        
'Public Programm variablen (in iniFile gesichert)
      Public iniDatenPath As String
      Public iniDateiFormat As String
      Public iniAutomatik As Boolean
      Public iniTitel As String
      Public iniYLegende As String
      Public iniXLegende As String
      Public iniYLgdMax As Long
      Public iniYLgdInt As Long
      Public iniCBColor As Long
      Public inilDLColor As Long
      Public iniHDatum As Boolean
      Public iniLegende As Boolean
      Public iniMPeriode As Boolean
      Public iniToffs As Integer
      Public iniATage As Integer
      
      
'IniModul_Initiale
      Public Sub INI_Initiale(Optional Default)
          Dim F As Integer
          On Error Resume Next
          INIFileName = App.Path & "\" & App.EXEName & ".ini"
          If Not IsMissing(Default) Then GoTo newini1
          If Dir(INIFileName) = "" Then
          'neue Ini mit Defaultwerten
newini:
            MsgBox cMsgIniErr, vbInformation, "Hinweis:"
newini1:     F = FreeFile
            Open INIFileName For Output As #F
            Print #F, "[Main]"
            Print #F, "1=" & App.Path & "\Daten,yyyymmdd.txt"
            Print #F, "2=Falsch"
            Print #F, "3=10"
            Print #F, "4=1"
            Print #F, ""
            Print #F, "[CHART]"
            Print #F, "0=Zeitreihenvisualisierung,MW,Uhr"
            Print #F, "1=10000,2000,-2147483643,255"
            Print #F, "2=Wahr"
            Print #F, "3=Wahr"
            Print #F, ""
            Print #F, "[Form]"
            Print #F, "frmMDI=100,100,800,12000"
            Close #F
          End If
          
          'Public Programm variablen einlesen
          On Error GoTo err
          iniConfig "Main", "1", "ssb", iniDatenPath, iniDateiFormat
          iniConfig "Main", "2", "b", iniAutomatik
          iniConfig "Main", "3", "i", iniToffs
          iniConfig "Main", "4", "i", iniATage
          
          iniConfig "CHART", "0", "sss", iniTitel, iniYLegende, iniXLegende
          iniConfig "CHART", "1", "lll", iniYLgdMax, iniYLgdInt, iniCBColor, inilDLColor
          iniConfig "CHART", "2", "b", iniHDatum
          iniConfig "CHART", "3", "b", iniMPeriode
          iniConfig "CHART", "4", "b", iniLegende
err:
          If err.Number <> 0 Then err.Number = 0: GoTo newini
          End Sub
          
'IniModul_Terminate
      Public Sub INI_Terminate(Optional Opt)
          iniConfig "Main", "1", , iniDatenPath, iniDateiFormat
          iniConfig "Main", "3", , iniToffs
          iniConfig "Main", "4", , iniATage
          
          iniConfig "CHART", "0", , iniTitel, iniYLegende, iniXLegende
          iniConfig "CHART", "1", , iniYLgdMax, iniYLgdInt, iniCBColor, inilDLColor
          iniConfig "CHART", "2", , iniHDatum
          iniConfig "CHART", "3", , iniMPeriode
          iniConfig "CHART", "4", , iniLegende
          
          If IsMissing(Opt) Then Exit Sub
          iniConfig "Main", "2", , iniAutomatik
          End Sub

    
'lesen/schreiben mehrer Variablen
      Public Sub iniConfig(ByRef Sect As String, ByRef Keyname As String, Optional ByRef LoadDTypen, _
      Optional ByRef val0 As Variant, Optional ByRef val1, Optional ByRef val2, Optional ByRef val3, _
      Optional ByRef val4 As Variant, Optional ByRef val5, Optional ByRef val6, Optional ByRef val7)
          Dim val As Variant, i As Integer
          On Error GoTo err
          If IsMissing(LoadDTypen) Then
                val = CStr(val0)
                If Not IsMissing(val1) Then val = val + cTrenn + CStr(val1)
                If Not IsMissing(val2) Then val = val + cTrenn + CStr(val2)
                If Not IsMissing(val3) Then val = val + cTrenn + CStr(val3)
                If Not IsMissing(val4) Then val = val + cTrenn + CStr(val4)
                If Not IsMissing(val5) Then val = val + cTrenn + CStr(val5)
                If Not IsMissing(val6) Then val = val + cTrenn + CStr(val6)
                If Not IsMissing(val7) Then val = val + cTrenn + CStr(val7)
                  INIVar(Sect$, Keyname$) = val
          Else
                val = String2Array(INIVar(Sect$, Keyname$), cTrenn)
                val0 = GetValType(val(0), Mid$(LoadDTypen, 1, 1))
                If Not IsMissing(val1) Then val1 = GetValType(val(1), Mid$(LoadDTypen, 2, 1))
                If Not IsMissing(val2) Then val2 = GetValType(val(2), Mid$(LoadDTypen, 3, 1))
                If Not IsMissing(val3) Then val3 = GetValType(val(3), Mid$(LoadDTypen, 4, 1))
                If Not IsMissing(val4) Then val4 = GetValType(val(4), Mid$(LoadDTypen, 5, 1))
                If Not IsMissing(val5) Then val5 = GetValType(val(5), Mid$(LoadDTypen, 6, 1))
                If Not IsMissing(val6) Then val6 = GetValType(val(6), Mid$(LoadDTypen, 7, 1))
                If Not IsMissing(val7) Then val7 = GetValType(val(7), Mid$(LoadDTypen, 8, 1))
          End If
err:
      End Sub
      
'Datentypen umwandeln
      Private Function GetValType(val, Dtyp) As Variant
          Select Case Dtyp
          Case "s": GetValType = CStr(val)
          Case "l": GetValType = CLng(val)
          Case "d": GetValType = CDbl(val)
          Case "b": GetValType = CBool(val)
          Case "t": GetValType = CDate(val)
          Case "i": GetValType = CInt(val)
          Case Else: GetValType = CLng(val)
          End Select
      End Function

'lesen/schreiben Form Eigenschaften
      Public Sub iniFormConfig(ByRef frm As Object, Save As Boolean)
          Dim val As Variant
          With frm
          Select Case Save
          Case True
                INIVar("Form", .Name) = CStr(.Top) + cTrenn + CStr(.Left) + cTrenn + CStr(.Height) + cTrenn + CStr(.Width)
          Case False
               val = String2Array(INIVar("Form", .Name), cTrenn)
               If Not IsEmpty(val(0)) Then
                  .Top = CLng(val(0)): .Left = CLng(val(1)): .Height = CLng(val(2)): .Width = CLng(val(3))
               End If
          End Select
          End With
      End Sub

'FormOption Einstellungen
      Public Sub Optionen(Optional Default)
      Dim s(1) As String, l(3) As Long, b(0) As Boolean
      Dim Automatik As Boolean
          On Error Resume Next
          iniConfig "Main", "2", "b", iniAutomatik
          If fOpt Is Nothing Then Set fOpt = New frm_OPT
            With fOpt
                .DatenPath = iniDatenPath
                .DateiFormat = iniDateiFormat
                .Automatik = IIf(iniAutomatik, 1, 0)
                .YLegende = iniYLegende
                .XLegende = iniXLegende
                .Titel = iniTitel
                .YLgdMax = iniYLgdMax
                .YLgdInt = iniYLgdInt
                .CBColor.BackColor = iniCBColor
                .DLColor.BackColor = inilDLColor
                .MWPeriode(0).Value = IIf(iniMPeriode, 1, 0)
                .Toffs = iniToffs
                .ATage = iniATage
            End With
          If Not IsMissing(Default) Then Exit Sub
          Set CDlg = New cls_ComDlg
          CDlg.ShowForm fOpt, 1
          Set CDlg = Nothing
          If err <> 0 Or fOpt.Abbruch Then Exit Sub
            With fOpt
              iniDatenPath = fOpt.DatenPath
              iniDateiFormat = fOpt.DateiFormat
              iniAutomatik = CBool(fOpt.Automatik)
              iniYLegende = .YLegende
              iniXLegende = .XLegende
              iniTitel = .Titel
              iniYLgdMax = CLng(.YLgdMax)
              iniYLgdInt = CLng(.YLgdInt)
              iniCBColor = CLng(.CBColor.BackColor)
              inilDLColor = CLng(.DLColor.BackColor)
              iniMPeriode = CBool(fOpt.MWPeriode(0).Value)
              iniToffs = CInt(fOpt.Toffs)
              iniATage = CInt(fOpt.ATage)
            End With
          Set fOpt = Nothing
          'Sichern
          INI_Terminate 1
          err = 0 'mErrorMsg 1
          End Sub

'Eingabe Prfung
      Public Function isInteger(ByVal Value As String, Optional oMax As Integer, Optional oMin As Integer) As Integer
          Dim i As Integer
          Value = Trim(Value): i = val(Value)
          If Len(Value) <> Len(Trim(Str(i))) Then i = 0
          If Not IsMissing(oMax) Then If i > oMax Then i = oMax
          If Not IsMissing(oMin) Then If i < oMin Then i = oMin
          isInteger = i
          End Function

      Public Function isLong(ByVal Value As String, Optional oMax As Long, Optional oMin As Long) As Long
          Dim l As Long
          Value = Trim(Value): l = val(Value)
          If Len(Value) <> Len(Trim(Str(l))) Then l = 0
          If Not IsMissing(oMax) Then If l > oMax Then l = oMax
          If Not IsMissing(oMin) Then If l < oMin Then l = oMin
          isLong = l
          End Function


'###################  Private ini Modul Property/Sub/Function  ################################################

'Appl. Variable lesen
      Private Property Get INIVar(Sect, Key)
          INIVar = ReadIniArray(Sect, Key)
          End Property

'Appl. Variable sichern
      Private Property Let INIVar(Sect, Key, ByVal val)
          On Error Resume Next
          If IsArray(val) Then val = Array2String(val, ",")
          WriteIni Sect, Key, val
          End Property

'String in Inifile schreiben
      Private Sub WriteIni(ByVal Sect$, ByVal Key$, ByVal Value$)
          Dim Result&
          Result = WritePrivateProfileString(Sect, Key, Value, INIFileName)
          End Sub

'Feld aus Inifile lesen
      Private Function ReadIniArray(ByVal Sect$, ByVal Key$, Optional ByRef Default$) As Variant
          Dim xArray()
          Dim Result&, Buffer$
          Dim l%, p%, z%
            If IsMissing(Default$) Then Default$ = vbNullString
            Buffer = Space(32767)
            Result = GetPrivateProfileString(Sect$, Key$, Default$, Buffer$, Len(Buffer$), INIFileName)
            Buffer = Trim(Left$(Buffer$, Result))
            ReadIniArray = Buffer
            End Function

'Feld in String wandeln
      Private Function Array2String(ByRef ArrayF, ByRef sTrenn$) As String
          Dim i%: i = 1
          Array2String = ArrayF(0)
          Do While i <= UBound(ArrayF)
              Array2String = Array2String & sTrenn$ & ArrayF(i): i = i + 1
          Loop
          End Function

'String in Feld wandeln
      Private Function String2Array(ByRef Buffer$, ByRef sTrenn$, Optional dump%) As Variant
          Dim xArray(), Result&, l%, p%, z%
          On Error Resume Next
          Buffer$ = Trim(Buffer$): Result = Len(Buffer$): ReDim xArray(0): l = 1: z = 0
          Do While l <= Result: p = InStr(l, Buffer & sTrenn$, sTrenn$)
            If p = 0 Then Exit Do
            If z > 0 Then ReDim Preserve xArray(0 To z)
            xArray(z) = Mid$(Buffer, l + dump%, p - l): z = z + 1: l = p + 1
          Loop
          String2Array = xArray
          End Function



















