Attribute VB_Name = "Module1"
'
' Modul: Modul1
'
' Author: Christoph Friedrich
' Letzte nderung: 20.02.2004
'

'Wert/Zeit Paar Datentype
Public Type Point
    TimePoint As String
    Value As Long
End Type

'Daten vom gestrigen Tag
Public Yesterday(1 To 96) As Point

'Daten vom heutigen Tag
Public Today(1 To 96) As Point

'
' Funktion LoadYesterdayData
'
' Rckgabe:
'  Erfolgreich: ja/nein
'
' Author: Christoph Friedrich
'
' Beschreibung:
' Ldt die Daten aus der Datei von Gestern
'
Public Function LoadYesterdayData() As Boolean
    On Error GoTo ErrHand
    
    Dim FileNum As Integer      'Freie Dateinummer
    Dim File As String          'Dateiname
    Dim Temp As String          'Temporre Variable zum Einlesen
    Dim ArrayPos As Integer     'Position im Array
    
    'Initialisieren der Variablen
    FileNum = FreeFile
    File = App.Path + "\Daten\" + Format(Date - 1, "yyyymmdd") + ".txt"
    ArrayPos = 1
    
    Open File For Input As #FileNum
        'Erste zwei Zeilen berspringen
        Seek #FileNum, 1
        Line Input #FileNum, Temp
        Line Input #FileNum, Temp
        
        Do While Not EOF(FileNum)
            'Einlesen und auseinandernehmen der Daten
            Line Input #FileNum, Temp
            Yesterday(ArrayPos).TimePoint = Trim$(Left$(Temp, InStr(Temp, " ")))
            Yesterday(ArrayPos).Value = Val(Mid$(Temp, InStr(Temp, " ") + 1))
            
            'Nchste Element im Array auswhlen
            ArrayPos = ArrayPos + 1
        Loop
    Close #FileNum
    
    'Rckgabe "Funktion erfolgreich"
    LoadYesterdayData = True
    Exit Function
    
ErrHand:
    'Fehler
    MsgBox "Fehler beim laden der Daten Datei!", vbCritical + vbOKOnly, "Diagramm"
    LoadYesterdayData = False
End Function

'
' Funktion LoadTodayData
' Erfolgreich: ja/nein
'
' Author: Christoph Friedrich
'
' Beschreibung:
' Ldt die Daten aus der Datei von Heute
'
Public Function LoadTodayData() As Boolean
    On Error GoTo ErrHand
    
    Dim FileNum As Integer      'Freie Dateinummer
    Dim File As String          'Dateiname
    Dim Temp As String          'Temporre Variable zum Einlesen
    Dim ArrayPos As Integer     'Position im Array
    
    'Initialisieren der Variablen
    FileNum = FreeFile
    File = App.Path + "\Daten\" + Format(Date, "yyyymmdd") + ".txt"
    ArrayPos = 1
    
    Open File For Input As #FileNum
        'Erste zwei Zeilen berspringen
        Seek #FileNum, 1
        Line Input #FileNum, Temp
        Line Input #FileNum, Temp
        
        Do While Not EOF(FileNum)
            'Einlesen und auseinandernehmen der Daten
            Line Input #FileNum, Temp
            Today(ArrayPos).TimePoint = Trim$(Left$(Temp, InStr(Temp, " ")))
            Today(ArrayPos).Value = Val(Mid$(Temp, InStr(Temp, " ") + 1))
            
            'Nchste Element im Array auswhlen
            ArrayPos = ArrayPos + 1
        Loop
    Close #FileNum
    
    'Rckgabe "Funktion erfolgreich"
    LoadTodayData = True
    Exit Function
    
ErrHand:
    'Fehler
    MsgBox "Fehler beim laden der Daten Datei!", vbCritical + vbOKOnly, "Diagramm"
    LoadTodayData = False
End Function

'
' Funktion GetMaxValue
'
' Rckgabe:
'  Grte Wert (an beiden Tagen)
'
' Author: Christoph Friedrich
'
' Beschreibung:
' Ermittelt den grten Wert von beiden Tagen
'
Public Function GetMaxValue() As Long
    Dim Temp As Long

    For i = 1 To 96
        If Yesterday(i).Value > Temp Then Temp = Yesterday(i).Value
        If Today(i).Value > Temp Then Temp = Today(i).Value
    Next i
    
    GetMaxValue = Temp
End Function

'
' Funktion CheckTimeDiff
'
' Rckgabe:
'  Zeitdifferenz zugro: ja/nein
'
' Parameter:
'  Anfangszeit (Zeichenkette)
'  Endzeit (Zeichenkette)
'  Endzeit = Heute: ja/nein
'
' Author: Christoph Friedrich
'
' Beschreibung:
' Prft ob die Differenz zwischen Anfangs und Endzeit mehr
' als eine viertel Stunde betrgt.
'
Public Function CheckTimeDiff(StartTime As String, EndTime As String, EndTimeToday As Boolean) As Boolean
    Dim StartHour As Integer        'Stunde der Startzeit
    Dim StartMinute As Integer      'Minute der Startzeit
    
    Dim EndHour As Integer          'Stunde der Endzeit
    Dim EndMinute As Integer        'Minute der Endzeit
    
    'Startzeit parsen
    StartHour = Left$(StartTime, 2)
    StartMinute = Mid$(StartTime, 4, 2)
    
    'Endzeit parsen
    EndHour = Left$(EndTime, 2)
    EndMinute = Mid$(EndTime, 4, 2)
     
    Select Case StartMinute
        Case "00"
            If EndMinute = "30" Or EndMinute = "00" Then
                CheckTimeDiff = False
                Exit Function
            End If
            If EndHour <> StartHour Then
                CheckTimeDiff = False
                Exit Function
            End If
                    
        Case "15"
            If EndMinute = "45" Or EndMinute = "15" Then
                CheckTimeDiff = False
                Exit Function
            End If
            If EndHour <> StartHour Then
                CheckTimeDiff = False
                Exit Function
            End If
            
        Case "30"
            If EndMinute = "00" Or EndMinute = "30" Then
                CheckTimeDiff = False
                Exit Function
            End If
            If EndHour <> StartHour Then
                CheckTimeDiff = False
                Exit Function
            End If
            
        Case "45"
            If EndMinute = "15" Or EndMinute = "45" Then
                CheckTimeDiff = False
                Exit Function
            End If
            If Val(EndHour) > Val(StartHour) + 1 And Not EndTimeToday Then
                CheckTimeDiff = False
                Exit Function
            ElseIf EndTimeToday Then
                If Val(StartHour) = 23 And Not Val(EndHour) = 0 Then
                    CheckTimeDiff = False
                    Exit Function
                End If
            End If
    End Select
    
    CheckTimeDiff = True
End Function

'
' Funktion GenTimeDiff
'
' Rckgabe:
'  Zeitdifferenz (in 15-Minuten-Ticks)
'
' Parameter:
'  Anfangszeit (Zeichenkette)
'  Endzeit (Zeichenkette)
'  Endzeit = Heute: ja/nein
'  Startzeit = Heute: ja/nein
'
' Author: Christoph Friedrich
'
' Beschreibung:
' Berechnet die Differenz zwischen den Zeiten als 15-Minuten-Ticks
'
Public Function GenTimeDiff(StartTime As String, EndTime As String, StartTimeToday As Boolean, EndTimeToday As Boolean) As Integer
    Dim StartHour As Integer
    Dim StartMinute As Integer
    
    Dim EndHour As Integer
    Dim EndMinute As Integer
    
    Dim Diff As Integer
    
    StartHour = Left$(StartTime, 2)
    StartMinute = Mid$(StartTime, 4, 2)
    
    EndHour = Left$(EndTime, 2)
    EndMinute = Mid$(EndTime, 4, 2)
    
    If StartTimeToday = EndTimeToday Then
        Diff = (EndHour - StartHour) * 60 + (EndMinute - StartMinute)
    Else
        EndHour = EndHour + 24
        Diff = (EndHour - StartHour) * 60 + (EndMinute - StartMinute)
    End If
    
    GenTimeDiff = Diff / 15
End Function
