Attribute VB_Name = "modAPI"
Option Explicit

Public Declare Function DrawText Lib "user32.dll" Alias "DrawTextA" _
   (ByVal hDC As Long, _
    ByVal lpStr As String, _
    ByVal nCount As Long, _
    lpRect As Rect, _
    ByVal wFormat As Long) As Long
    
Public Declare Function RoundRect Lib "gdi32.dll" ( _
  ByVal hDC As Long, _
  ByVal X1 As Long, _
  ByVal Y1 As Long, _
  ByVal X2 As Long, _
  ByVal Y2 As Long, _
  ByVal X3 As Long, _
  ByVal Y3 As Long _
) As Long

Public Declare Function GetCursorPos Lib "user32.dll" ( _
  ByRef lpPoint As POINTAPI _
) As Long

Public Declare Function ClientToScreen Lib "user32.dll" ( _
  ByVal hwnd As Long, _
  ByRef lpPoint As POINTAPI _
) As Long


Public Type POINTAPI
    X As Long
    Y As Long
End Type

    
Public Type Rect
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type

Public Type DataType
    X   As Long
    Y   As Long
    Tag As String
End Type

Public Enum StyleProp
    stlNormal = 0
    stlFlat = 1
    stlNone = 2
    stlwinXP = 3
End Enum

Public Enum PointStyleProp
    stlPoint = 0
    stlCircle = 1
End Enum

Public Const DT_LEFT                As Long = &H0
Public Const DT_CALCRECT            As Long = &H400

'---------Farbkonstanten---------
Public Const WHITE                  As Long = 16777215 'RGB(255, 255, 255)
Public Const INNER_BORDER_COLOR_XP  As Long = 12500670 'RGB(190, 190, 190)
Public Const OUTER_BORDER_COLOR_XP  As Long = 6842472  'RGB(104, 104, 104)
Public Const OUTER_BORDER_COLOR_L   As Long = 10591645 'RGB(157, 157, 161)
Public Const OUTER_BORDER_COLOR_R   As Long = WHITE    'RGB(255, 255, 255)
Public Const INNER_BORDER_COLOR_L   As Long = 6582129  'RGB(113, 111, 100)
Public Const INNER_BORDER_COLOR_R   As Long = 14872561 'RGB(241, 239, 226)
Public Const DEFAULT_POINT_COLOR    As Long = 16751460 'RGB(100, 155, 255)

'---------Datencontainer---------
Public Const ITEMCOUNT      As Long = 96    '24 hours = 96 quarterhours, 0 To 96 sind 97 Items: So wird auch die Startzeit am Vortag mit angezeigt!
Public Datas(ITEMCOUNT)     As DataType     'Hier werden die eingelesenen Daten gespeichert ...
Public MaxItem              As Long         'Grter Wert in Datas
Public DStartTime           As Date         'Zu welcher Uhrzeit startet das Diagramm?

'---------Allgemeines---------
Public Const MEASURE_NAME       As String = "Pegelstand"    'Name des auszulesenden Wertes
Public Const MEASURE_UNIT       As String = "cm"            'Maeinheit des auszulesenden Wertes
Public Const TOOLTIP_WAIT_TIME  As Long = 5                 'Zeit in 100ms bis zum Popup eines ToolTips
Public Const NEAR_N             As Long = 3                 'Wie nahe muss der Mauszeiger einem Punkt fr ToolTip sein?

Public Function Near(ByVal xIs As Single, ByVal yTo As Single) As Boolean
    If xIs > yTo Then
        If xIs - NEAR_N <= yTo Then Near = True
    ElseIf xIs < yTo Then
        If xIs + NEAR_N >= yTo Then Near = True
    Else                            'xIs = yTo !!!
        Near = True
    End If
End Function
