VERSION 5.00
Begin VB.UserControl ctlDiagramm 
   AutoRedraw      =   -1  'True
   ClientHeight    =   3600
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4800
   ScaleHeight     =   240
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   320
   ToolboxBitmap   =   "ctlDiagramm.ctx":0000
End
Attribute VB_Name = "ctlDiagramm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

'API-Deklarationen - fr FileExists-Funktion bentigt
Private Const INVALID_HANDLE_VALUE = -1
Private Const MAX_PATH = 260

Private Type FILETIME
   dwLowDateTime As Long
   dwHighDateTime As Long
End Type
Private Type WIN32_FIND_DATA
   dwFileAttributes As Long
   ftCreationTime As FILETIME
   ftLastAccessTime As FILETIME
   ftLastWriteTime As FILETIME
   nFileSizeHigh As Long
   nFileSizeLow As Long
   dwReserved0 As Long
   dwReserved1 As Long
   cFileName As String * MAX_PATH
   cAlternate As String * 14
End Type

Private Declare Function FindFirstFile Lib "Kernel32" Alias "FindFirstFileA" (ByVal lpFileName As String, lpFindFileData As WIN32_FIND_DATA) As Long
Private Declare Function FindClose Lib "Kernel32" (ByVal hFindFile As Long) As Long

'Usercontrol-Deklarationen
Private Type myDiagramm 'Eigene Struktur um Eigenschaften zu speichern
    mBackColor As OLE_COLOR 'Hintergrundfarbe des Controls
    mFont As Font 'Schriftart
    mTextColor As OLE_COLOR 'Schriftfarbe
    mLineColor As OLE_COLOR 'Linienfarbe (Diagrammlinie)
    mPath As String 'Pfad, aus dem die Textdateien gelesen werden sollen
    mScalY As Single 'Wert fr vertikale Skalierung: 0=keine Anzeige, _
        1=automatische Anzeige, anderer Wert>0 = Schritte, _
        in denen gezeichnet werden soll (zB. 1000 -> in 1000er Schritten)
    mScalX As Single 'Wert fr horizontale Skalierung: 0=keine Anzeige, _
        anderer Wert>0 = Schritte, in denen gezeichnet werden soll _
        (zB. 1 -> in 1er Schritten; 2 -> in 2er Schritten)
    mGridColor As OLE_COLOR 'Linienfarbe der Gitternetzlinien
    mGridX As Boolean 'bestimmt, ob horizontale Linien angezeigt werden sollen
    mGridY As Boolean 'bestimmt, ob vertikale Linien angezeigt werden sollen
    mScaleLineColor As OLE_COLOR 'bestimmt die Farbe der Skalierungslinien (die ber dem Text)
    mDistanceTop As Long 'bestimmt den oberen "Einzug" (in Pixel)
    mDistanceRight As Long 'bestimmt den rechten "Einzug" (in Pixel)
    mAutoRoundValues As Boolean 'bestimmt, ob die Werte gerundet angezeigt werden (zB. maxValue = 9873 -> gerundet, Anzeige bis 10000)
End Type

'Events
'wenn Textdatei von gestern fehlt
Public Event MissingTextFileYesterday(ByVal sFile As String)
'wenn Textdatei von heute fehlt
Public Event MissingTextFileToday(ByVal sFile As String)
'wenn Zeichnen fertig ist
Public Event RedrawFinished()

'Die bentigten Variablen
Dim UC As myDiagramm 'Struktur-Variable
Dim Values(1 To 97) As String 'die gespeicherten Werte
Dim sText1 As String 'die erste Textdatei (von gestern)
Dim sText2 As String 'die zweite Textdatei (von heute)
Dim sPath As String 'der Pfad mit Backslash am Ende
Dim sFilename As String 'Variable fr Dateinamen
Dim uTime As Variant 'Die auf Viertelstunden gerundete Zeit
Dim n As Single 'ein Zhler
Dim i, i2 'Zhler
Dim Counter As Long 'Zhler
Dim Counter2 As Long 'Zhler
Dim Arr1() As String 'die erste Textdatei gesplitted
Dim Arr2() As String 'die zweite Textdatei gesplitted
Dim bBefore As Boolean 'Speichervariable, ob die erste Textdatei existiert
Dim Merker1 As Integer 'Speichervariable, ab welchem Index in der ersten Textdatei gewertet werden soll
Dim Merker2 As Integer 'Speichervariable, bis zu welchem Index in der zweiten Textdatei gewertet werden soll
Dim defTime As Variant 'Variable fr Zeit
Dim sTime As String 'Variable fr Zeit
Dim sValue As String 'der aktuelle Wert
Dim bNotRedraw As Boolean
Dim dX As Single 'ab welchem X gezeichnet werden darf
Dim dY As Single 'ab welchem Y gezeichnet werden darf
Dim dW As Single 'die erlaubte Zeichenbreite fr Diagramm
Dim dH As Single 'die erlaubte Zeichenhhe fr Diagramm
Dim maxValue As Long 'der maximale Wert, der whrend dem Einlesen ermittelt wird
Dim pD As Single 'Speichervariable frs Zeichnen
Dim pT As String 'Speichervariable frs Zeichnen
Dim lVal As Single 'Speichervariable frs Zeichnen
Dim lX As Single 'Speichervariable frs Zeichnen
Dim lY As Single 'Speichervariable frs Zeichnen
Dim nX As Single 'Speichervariable frs Zeichnen
Dim nY As Single 'Speichervariable frs Zeichnen
Dim maxX As Single 'Speichervariable frs Zeichnen
Dim lVal2 As Single 'Speichervariable frs Zeichnen

'Funktion, die Text aus einer Textdatei liest
Private Function TextRead(sFile As String) As String
Dim Number As Integer
Dim size As Long
Number = FreeFile

Open sFile For Input As Number
size = LOF(Number)
TextRead = Input(size, Number)
Close Number
End Function

'Funktion, die zurckgibt, ob ein Pfad existiert
Public Function FileExists(sFile As String) As Boolean
Dim WFD As WIN32_FIND_DATA
Dim hFile As Long
hFile = FindFirstFile(sFile, WFD)
FileExists = hFile <> INVALID_HANDLE_VALUE
Call FindClose(hFile)
End Function

'die Zeichenprozedur
Public Sub Redraw()
If bNotRedraw Then Exit Sub 'Wenn nicht gezeichnet werden soll, dann Sub beenden

UserControl.Cls 'lscht Zechenflche
UserControl.BackColor = UC.mBackColor 'weist Hintergrundfarbe zu

If Ambient.UserMode = False Then 'wenn in der IDE, nur Namen zeichnen
CurrentX = (ScaleWidth - TextWidth(UserControl.Name)) / 2
CurrentY = (ScaleHeight - TextHeight(UserControl.Name)) / 2
Print UserControl.Name
Exit Sub
End If

'VORBEREITUNGEN UND BERECHNEN-----------------------------------------------
'Pfad zuweisen und berprfen, ob Backslash am Ende
sPath = UC.mPath
If Right(sPath, 1) <> "\" Then sPath = sPath & "\"

'div. Zuweisungen
bBefore = False
Erase Arr1
Erase Arr2
maxValue = 0

'berprfen, welche Zeit und zuweisen des bentigten Pfades
If Format(Time, "hh:mm:ss") <> "00:00:00" Then
sFilename = sPath & Format(DateAdd("d", -1, Date), "yyyymmdd") & ".txt"
    'bestimmen, ob Textdatei von gestern existiert
    If FileExists(sFilename) Then
    sText1 = TextRead(sFilename) 'dann laden
    bBefore = True 'und kennzeichnen
    Else
    'ansonsten Event auslsen
    RaiseEvent MissingTextFileYesterday(Format(DateAdd("d", -1, Date), "yyyymmdd") & ".txt")
    End If
End If

'berprfen, welche Zeit und zuweisen des bentigten Pfades
sFilename = sPath & Format(Date, "yyyymmdd") & ".txt"
'bestimmen, ob Textdatei von heute existiert
If FileExists(sFilename) Then
sText2 = TextRead(sFilename) 'dann laden
Else
'ansonsten Event auslsen
RaiseEvent MissingTextFileToday(Format(Date, "yyyymmdd") & ".txt")
End If

'bestimmen der aktuellen Zeit und auf Viertelstunden runden
n = Left(Right(Format(Time, "hh:mm"), 2) / 15, 1)
uTime = Format(Time, "hh") & ":" & Format(n * 15, "00")

'Textdatei in Array splitten
Arr2 = Split(sText2, vbCrLf)
'Array durchlaufen
For i = 2 To UBound(Arr2)
    If Trim(Arr2(i)) <> "" Then 'Leere Strings einfach ignorieren
    sTime = Left(Arr2(i), 5)
        'und berprfen...
        'ist die auslesene Zeit (wenn Zeit) des Arrayelements grer oder gleich der _
        aktuelen Zeit? Wenn ja, dann merke dir diese Position
        If sTime >= uTime And IsDate(sTime) Then
        Merker2 = i
        Exit For
        End If
    End If
Next i

'Array mit Leer-Elementen fllen
For i = LBound(Values) To UBound(Values)
Values(i) = ""
Next i

Counter = 1 'Zhler zurcksetzen

'Wenn erste Textdatei existiert, dann...
If bBefore Then
Arr1 = Split(sText1, vbCrLf) 'Textdatei splitten
    'Array durchlaufen
    For i = 2 To UBound(Arr1)
        If Trim(Arr1(i)) <> "" Then 'Leere Strings einfach ignorieren
        sTime = Left(Arr1(i), 5)
            'und berprfen...
            'ist die auslesene Zeit (wenn Zeit) des Arrayelements grer oder gleich der _
            aktuelen Zeit? Wenn ja, dann merke dir diese Position
            If sTime >= uTime And IsDate(sTime) Then
            Merker1 = i
            Exit For
            End If
        End If
    Next i
    
    defTime = uTime 'DefaultTime auf aktuelle Zeit setzen (= Sollzeit)

    For i = Merker1 To UBound(Arr1) 'Durchluft den Array von der Position, die er sich gemerkt hat
        If Trim(Arr1(i)) <> "" Then 'Leere Strings einfach ignorieren
        sTime = Left(Arr1(i), 5)
            If sTime <> defTime And IsDate(sTime) Then 'wenn ausgelesene Zeit (wenn Zeit) etwas anderes ist als die DefaultTime dann..
            n = (DateDiff("s", defTime, sTime) / 60) / 15 'berechnen der _
            Viertelstundenunterschiede (zB. von 15:30 und 16:00 -> 2 Viertelstunden)
                If n > 0 Then 'entspricht die angezeigte Zeit nicht der, die sie eigentlich sein soll _
                (Eintrge fehlen,...) dann erhhe den Value-Zhler und korrigiere die Sollzeit
                Counter = Counter + n 'Hinzufgen der Anzahl
                defTime = Format(DateAdd("s", n * 15 * 60, defTime), "hh:mm") 'Sollzeit "korrigieren"
                End If
            End If
        
        'ausgelesenen Wert neben Datum zuweisen
        sValue = Arr1(i)
        Values(Counter) = Trim(Right(sValue, Len(sValue) - 5))
            'maxValue korrigieren, falls notwendig
            If CLng(IIf(Values(Counter) <> "", Values(Counter), 0)) > maxValue Then maxValue = CLng(Values(Counter))
            
            'Sollzeit korigieren
            If i = UBound(Arr1) Then
            defTime = "24:00"
            Else
            defTime = Format(DateAdd("s", 15 * 60, defTime), "hh:mm")
            End If
        Counter = Counter + 1 'Zhler erhhen (fr Values(?))
        End If
    Next i
End If

defTime = "00:00" 'da heutiger Tag -> Sollzeit beginnt bei 0 Uhr

For i = 2 To Merker2 'von 2, da erst bei 3. Eintrag Daten beginnen (Array beginnt bei 0)
    If Trim(Arr2(i)) <> "" Then 'Leere Strings einfach ignorieren
    sTime = Left(Arr2(i), 5)
        If sTime <> defTime And IsDate(sTime) Then 'wenn ausgelesene Zeit (wenn Zeit) etwas anderes ist als die DefaultTime dann..
        n = (DateDiff("s", defTime, sTime) / 60) / 15 'berechnen der _
        Viertelstundenunterschiede (zB. von 15:30 und 16:00 -> 2 Viertelstunden)
            If n > 0 Then 'entspricht die angezeigte Zeit nicht der, die sie eigentlich sein soll _
            (Eintrge fehlen,...) dann erhhe den Value-Zhler und korrigiere die Sollzeit
            Counter = Counter + n 'Hinzufgen der Anzahl
            defTime = Format(DateAdd("s", n * 15 * 60, defTime), "hh:mm") 'Korrigieren der Sollzeit
                If defTime > uTime Then Exit For 'wenn bereits Sollzeit hher als Maximalzeit, dann beenden
            End If
        End If
    'ausgelesenen Wert neben Datum zuweisen
    sValue = Arr2(i)
    Values(Counter) = Trim(Right(sValue, Len(sValue) - 5))
        If CLng(IIf(Values(Counter) <> "", Values(Counter), 0)) > maxValue Then maxValue = CLng(Values(Counter)) 'maxValue korrigieren
        
    defTime = Format(DateAdd("s", 15 * 60, defTime), "hh:mm") 'Sollzeit korrigieren
    Counter = Counter + 1 'Zhler erhhen
    End If
Next i

If UC.mAutoRoundValues Then maxValue = RoundValue(maxValue)

'ZEICHNEN-------------------------------------------------------------------
If Not UC.mFont Is Nothing Then Set UserControl.Font = UC.mFont 'Schriftart zuweisen

'Berechnen der Abstnde und Ausmae
dX = TextWidth(maxValue) + 7
dY = TextHeight("A") + 4
dH = ScaleHeight - dY
dW = ScaleWidth - dX

UserControl.ForeColor = UC.mTextColor 'Schriftfarbe zuweisen
Counter2 = 0 'Zhler zurcksetzen
maxX = 0
pT = -0.25 'da schon gelcih zu Beginn Zhler erhht wird, einfach mit Minus-Wert anfangen, um 0 zu zeichnen

'Horizontale Skalierung
If UC.mScalX > 0 Then 'Wenn Skalierung angezeigt werden soll
pD = (dW - UC.mDistanceRight) / 24 'Zuweisen der Skalierungsabstnde
lVal = 4 * UC.mScalX 'Zhler fr horizontalen Text
    For i = dX To ScaleWidth Step (pD / 4) 'Breite durchlaufen
    pT = CStr(CSng(pT) + 0.25) 'zu zeichnenden Text ermitteln
        If Counter2 > 96 Then Exit For
            If lVal = 4 * UC.mScalX Then
            'Text ausrichten
            CurrentX = i - TextWidth(pT) / 2
            CurrentY = dH + 2
                If CurrentX > ScaleWidth - TextWidth(pT) Then _
                CurrentX = ScaleWidth - TextWidth(pT) 'Wenn Text laut _
                Berechnung schon auerhalb des Diagramms -> _
                noch im Diagramm zeichnen, damit nicht abgeschnitten
            Print pT 'Text zeichnen
            lVal = 0 'Zhler zurcksetzen
            End If
    Line (i, UC.mDistanceTop)-(i, dH), UC.mGridColor 'Gitternetzlinie zeichnen
    maxX = i 'uerste Linie ermitteln
    lVal = lVal + 1 'Zhler erhhen
    Counter2 = Counter2 + 1 'Zhler erhhen
    Next i
End If

Counter2 = 0 'Zhler zurcksetzen
'Vertikale Skalierung
If UC.mScalY > 1 And maxValue > 0 Then 'Wenn Skalierung in Schritten angezeigt werden soll und maxValue berhaupt>0 ist, dann...
pD = ((dH - UC.mDistanceTop) / maxValue) * UC.mScalY 'Zuweisen der Skalierungsabstnde
    For i = dH To UC.mDistanceTop Step -pD 'Hhe durchlaufen
    Line (dX, i)-(maxX, i), UC.mGridColor 'Gitternetzlinie zeichnen
        If Counter2 > 0 Then
        'Text ausrichten
        CurrentY = i - TextHeight("A") / 2
        CurrentX = dX - TextWidth(Counter2) - 5
            If CurrentY < 0 Then CurrentY = 0 'Wenn Text laut _
                Berechnung schon auerhalb des Diagramms -> _
                noch im Diagramm zeichnen, damit nicht abgeschnitten
        Print Counter2 'Text zeichnen
        End If
    Counter2 = Counter2 + UC.mScalY 'Zhler erhhen
    Next i
ElseIf UC.mScalY = 1 Then 'Wenn Skalierung automatisch angezeigt werden soll, dann...
    If maxValue > 0 Then 'Wenn maxValue bnerhaupt >0 ist, dann...
        'Skalierungsmglichkeit berechnen
        If dH - UC.mDistanceTop >= maxValue Then 'Wenn maximaler Wert kleiner als Zeichenhhe
        pD = ((dH - UC.mDistanceTop) / maxValue) * (maxValue / 5) 'Zuweisen der Skalierungsabstnde
        lVal = dH
        Else
        'Berechnung fr aktezpables Aussehen
        lVal2 = maxValue / dH
            If lVal2 > 100 Then
            lVal = dH * (lVal2 / 20)
            Else
            lVal = dH / 2
            End If
        pD = ((dH - UC.mDistanceTop) / maxValue) * lVal 'Zuweisen der Skalierungsabstnde
        End If
    End If
    
    For i = dH To UC.mDistanceTop Step -pD 'Hhe durchlaufen
    Line (dX, i)-(maxX, i), UC.mGridColor 'Gitternetzlinie zeichnen
        If Counter2 > 0 Then
        'Text ausrichten
        CurrentY = i - TextHeight("A") / 2
        CurrentX = dX - TextWidth(Counter2) - 5
            If CurrentY < 0 Then CurrentY = 0 'Wenn Text laut _
                Berechnung schon auerhalb des Diagramms -> _
                noch im Diagramm zeichnen, damit nicht abgeschnitten
        Print Counter2 'Text zeichnen
        End If
    Counter2 = Counter2 + lVal 'Zhler erhhen
    Next i
End If

pD = ((dW - UC.mDistanceRight) / 24) / 4 'Zuweisen der Skalierungsabstnde
nX = dX + pD 'nX = neues X, nY = neues Y

'Wenn erste Textdatei nicht vorhanden, dann mitten im Diagramm zu zeichnen beginnen
If bBefore = False Then _
nX = nX + ((24 * 60 - (Hour(uTime) * 60 + Minute(uTime))) / 15) * pD

'Ganz oben auf jeden Fall eine Gitternetzlinie zeichnen
Line (dX, UC.mDistanceTop)-(ScaleWidth - UC.mDistanceRight, UC.mDistanceTop), UC.mGridColor

'lX = letztes X, lY = letztes Y

'Werte durchlaufen und Linien zeichnen
For i = LBound(Values) + 1 To UBound(Values)
    If Values(i - 1) <> "" Then 'Wenn letzter Value nicht leer
    lX = nX - pD 'letzte X-Position ist neue X-Position - Skalierungsabstand
    lY = dH - ((dH - UC.mDistanceTop) / maxValue) * Values(i - 1) 'letzte Y-Position berechnen
    End If
    
    'Wenn aktueller Value nicht leer
    If Values(i) <> "" Then _
    nY = dH - ((dH - UC.mDistanceTop) / maxValue) * Values(i) 'aktuelle Y-Position berechnen
    
    If Values(i - 1) <> "" And Values(i) <> "" Then 'wenn beide Values nicht leer, dann zeichnen
    Line (lX, lY)-(nX, nY), UC.mLineColor 'Linie zeichnen
    End If

nX = nX + pD 'neues X berechnen
Next i

'Skalierungslinien zeichnen
Line (dX, 0)-(dX, dH), UC.mScaleLineColor
Line (dX, dH)-(ScaleWidth, dH), UC.mScaleLineColor

'Event auslsen
RaiseEvent RedrawFinished
End Sub

'FOLGENDE PROPERTIES WERDEN OBEN IN DER STRUKTUR ERKLRT
Public Property Get BackColor() As OLE_COLOR
BackColor = UC.mBackColor
End Property

Public Property Let BackColor(ByVal vNew As OLE_COLOR)
UC.mBackColor = vNew
PropertyChanged "BackColor"
Call Redraw
End Property

Public Property Get Font() As Font
Set Font = UC.mFont
End Property

Public Property Set Font(ByVal vNew As Font)
Set UC.mFont = vNew
PropertyChanged "Font"
Call Redraw
End Property

Public Property Get TextColor() As OLE_COLOR
TextColor = UC.mTextColor
End Property

Public Property Let TextColor(ByVal vNew As OLE_COLOR)
UC.mTextColor = vNew
PropertyChanged "TextColor"
Call Redraw
End Property

Public Property Get LineColor() As OLE_COLOR
LineColor = UC.mLineColor
End Property

Public Property Let LineColor(ByVal vNew As OLE_COLOR)
UC.mLineColor = vNew
PropertyChanged "LineColor"
Call Redraw
End Property

Public Property Get Path() As String
Path = UC.mPath
End Property

Public Property Let Path(ByVal vNew As String)
UC.mPath = vNew
PropertyChanged "Path"
Call Redraw
End Property

Public Property Get ScalX() As Single
ScalX = UC.mScalX
End Property

Public Property Let ScalX(ByVal vNew As Single)
UC.mScalX = vNew
PropertyChanged "ScalX"
Call Redraw
End Property

Public Property Get ScalY() As Single
ScalY = UC.mScalY
End Property

Public Property Let ScalY(ByVal vNew As Single)
UC.mScalY = vNew
PropertyChanged "ScalY"
Call Redraw
End Property

Public Property Get GridColor() As OLE_COLOR
GridColor = UC.mGridColor
End Property

Public Property Let GridColor(ByVal vNew As OLE_COLOR)
UC.mGridColor = vNew
PropertyChanged "GridColor"
Call Redraw
End Property

Public Property Get GridX() As Boolean
GridX = UC.mGridX
End Property

Public Property Let GridX(ByVal vNew As Boolean)
UC.mGridX = vNew
PropertyChanged "GridX"
Call Redraw
End Property

Public Property Get GridY() As Boolean
GridY = UC.mGridY
End Property

Public Property Let GridY(ByVal vNew As Boolean)
UC.mGridY = vNew
PropertyChanged "GridY"
Call Redraw
End Property

Public Property Get ScaleLineColor() As OLE_COLOR
ScaleLineColor = UC.mScaleLineColor
End Property

Public Property Let ScaleLineColor(ByVal vNew As OLE_COLOR)
UC.mScaleLineColor = vNew
PropertyChanged "ScaleLineColor"
Call Redraw
End Property

Public Property Get DistanceTop() As Long
DistanceTop = UC.mDistanceTop
End Property

Public Property Let DistanceTop(ByVal vNew As Long)
UC.mDistanceTop = vNew
PropertyChanged "DistanceTop"
Call Redraw
End Property

Public Property Get DistanceRight() As Long
DistanceRight = UC.mDistanceRight
End Property

Public Property Let DistanceRight(ByVal vNew As Long)
UC.mDistanceRight = vNew
PropertyChanged "DistanceRight"
Call Redraw
End Property

Public Property Get AutoRoundValues() As Boolean
AutoRoundValues = UC.mAutoRoundValues
End Property

Public Property Let AutoRoundValues(ByVal vNew As Boolean)
UC.mAutoRoundValues = vNew
PropertyChanged "AutoRoundValues"
Call Redraw
End Property
'ENDE PROPERTIES

Private Sub UserControl_Resize()
'das stndige zeichnen whrend dem Resizen in der Runtime whre tdlich...
'deshalb nur zeichnen, wenn in der IDE (zeichnet nur Namen)
If Ambient.UserMode = False Then Call Redraw
End Sub

'Initialisiert alle Eigenschaften und fllt Werte
Private Sub UserControl_InitProperties()
bNotRedraw = True 'Damit nicht stndig Neuzeichnen ausgelst wird, erst am Schluss zeichnen (Performance)

BackColor = vbWhite
Set Font = Parent.Font
TextColor = vbBlack
LineColor = vbBlue
Path = App.Path
ScalX = 1
ScalY = 1000
GridColor = &HC0C0C0
GridX = True
GridY = True
ScaleLineColor = vbBlack
DistanceTop = 10
DistanceRight = 10
AutoRoundValues = False

bNotRedraw = False

Call Redraw
End Sub

'liest Eigenschaften
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
bNotRedraw = True 'Damit nicht stndig Neuzeichnen ausgelst wird, erst am Schluss zeichnen (Performance)

With PropBag
BackColor = .ReadProperty("BackColor", vbWhite)
Set Font = .ReadProperty("Font", Parent.Font)
TextColor = .ReadProperty("TextColor", vbBlack)
LineColor = .ReadProperty("LineColor", vbBlue)
Path = .ReadProperty("Path", App.Path)
ScalX = .ReadProperty("ScalX", 1)
ScalY = .ReadProperty("ScalY", 1000)
GridColor = .ReadProperty("GridColor", &HC0C0C0)
GridX = .ReadProperty("GridX", True)
GridY = .ReadProperty("GridY", True)
ScaleLineColor = .ReadProperty("ScaleLineColor", vbBlack)
DistanceTop = .ReadProperty("DistanceTop", 10)
DistanceRight = .ReadProperty("DistanceRight", 10)
AutoRoundValues = .ReadProperty("AutoRoundValues", False)
End With

bNotRedraw = False

Call Redraw
End Sub

'schreibt Eigenschaften
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
With PropBag
.WriteProperty "BackColor", BackColor, vbWhite
.WriteProperty "Font", Font, Parent.Font
.WriteProperty "TextColor", TextColor, vbBlack
.WriteProperty "LineColor", LineColor, vbBlue
.WriteProperty "Path", Path, App.Path
.WriteProperty "ScalX", ScalX, 1
.WriteProperty "ScalY", ScalY, 1000
.WriteProperty "GridColor", GridColor, &HC0C0C0
.WriteProperty "GridX", GridX, True
.WriteProperty "GridY", GridY, True
.WriteProperty "ScaleLineColor", ScaleLineColor, vbBlack
.WriteProperty "DistanceTop", DistanceTop, 10
.WriteProperty "DistanceRight", DistanceRight, 10
.WriteProperty "AutoRoundValues", AutoRoundValues, False
End With
End Sub

'Hilfsfunktion um maxValue zu runden
Private Function RoundValue(ByVal GetValue) As Long
If GetValue <= 1 Then RoundValue = GetValue: Exit Function 'bei Zahl kleinergleich 1 kein Sinn

'da laut Beschreibung theoretisches Maximum=250000 reicht diese Lsung der Funktion aus
If Len(GetValue) = 2 Then
    If Right(GetValue, 1) <> "0" Then
    RoundValue = (CLng(Left(GetValue, 1)) + 1) * 10
    Else
    RoundValue = GetValue
    End If
ElseIf Len(GetValue) = 3 Then
    If Right(GetValue, 2) <> "00" Then
    RoundValue = (CLng(Left(GetValue, 2)) + 1) * 10
    Else
    RoundValue = GetValue
    End If
ElseIf Len(GetValue) = 4 Then
    If Right(GetValue, 2) <> "00" Then
    RoundValue = (CLng(Left(GetValue, 3)) + 1) * 10
    Else
    RoundValue = GetValue
    End If
ElseIf Len(GetValue) = 5 Then
    If Right(GetValue, 2) <> "00" Then
    RoundValue = (CLng(Left(GetValue, 3)) + 1) * 100
    Else
    RoundValue = GetValue
    End If
ElseIf Len(GetValue) = 6 Then
    If Right(GetValue, 2) <> "00" Then
    RoundValue = (CLng(Left(GetValue, 3)) + 1) * 1000
    Else
    RoundValue = GetValue
    End If
Else
RoundValue = GetValue
End If
End Function
