VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsCommonDialog"
Attribute VB_GlobalNameSpace = True
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False

'Dieser Source stammt von http://www.activevb.de
'und kann frei verwendet werden. Fr eventuelle Schden
'wird nicht gehaftet.
'
'Um Fehler oder Fragen zu klren, nutzen Sie bitte unser Forum.
'Ansonsten viel Spa und Erfolg mit diesem Source !
'

'################################################################################
' Modul        : cCommonDialog
' Beschreibung : ComDlg32.ocx Replacement
'
'
' Erstellt von : Christoph von Wittich
' Erstellt am  : 02.03.2002
'
' Copyright (C) 2000-2002 bei Christoph von Wittich, alle Rechte vorbehalten.
' Kontakt: Chris_vw@web.de

Option Explicit

Private Const LOGPIXELSY = 90
Private Const LF_FACESIZE = 32
Private Const CCHDEVICENAME = 32
Private Const CCHFORMNAME = 32

Private Const SCREEN_FONTTYPE = &H2000
Private Const CC_ANYCOLOR = &H100
Private Const CC_RGBINIT = &H1
Private Const GMEM_ZEROINIT = &H40
Private Const GMEM_MOVEABLE = &H2
Private Const DN_DEFAULTPRN = &H1
Private Const MAX_PATH = 260
Private Const OFN_Readonly = &H1
Private Const OFN_Overwriteprompt = &H2
Private Const OFN_HideReadOnly = &H4
Private Const OFN_NoChangeDir = &H8
Private Const OFN_Showhelp = &H10
Private Const OFN_EnableHook = &H20
Private Const OFN_EnableTemplate = &H40
Private Const OFN_EnableTemplateHandle = &H80
Private Const OFN_NoValidate = &H100
Private Const OFN_AllowMultiselect = &H200
Private Const OFN_ExtensionDifferent = &H400
Private Const OFN_CreatePrompt = &H2000
Private Const OFN_Shareaware = &H4000
Private Const OFN_NoReadOnlyReturn = &H8000
Private Const OFN_NoTestFileCreate = &H10000
Private Const OFN_NoNetworkButton = &H20000
Private Const OFN_NoLongNames = &H40000
Private Const OFN_Explorer = &H80000
Private Const OFN_NoDefferenceLinks = &H100000
Private Const OFN_LongNames = &H200000
Private Const CC_FULLOPEN = &H2
Private Const FF_ROMAN = 16
Private Const DEFAULT_PITCH = 0
Private Const FW_NORMAL = 400
Private Const FW_BOLD = 700
Private Const DEFAULT_CHARSET = 1
Private Const CLIP_DEFAULT_PRECIS = 0
Private Const CF_PRINTERFONTS = &H2
Private Const CF_BOTH = (&H1 Or &H2)
Private Const CF_FORCEFONTEXIST = &H10000
Private Const CF_INITTOLOGFONTSTRUCT = &H40&
Private Const CF_LIMITSIZE = &H2000&
Private Const REGULAR_FONTTYPE = &H400
Private Const OUT_DEFAULT_PRECIS = 8
Private Const DM_ORIENTATION = &H1&
Private Const PD_SELECTION = &H1
Private Const PD_PAGENUMS = &H2

Private Type PrintDlg
    lStructSize As Long
    hwndOwner As Long
    hDevMode As Long
    hDevNames As Long
    hDC As Long
    pFlags As Long
    nFromPage As Integer
    nToPage As Integer
    nMinPage As Integer
    nMaxPage As Integer
    nCopies As Integer
    hInstance As Long
    lCustData As Long
    lpfnPrintHook As Long
    lpfnSetupHook As Long
    lpPrintTemplateName As String
    lpSetupTemplateName As String
    hPrintTemplate As Long
    hSetupTemplate As Long
End Type

Private Type DevNames
    wDriverOffset As Integer
    wDeviceOffset As Integer
    wOutputOffset As Integer
    wDefault As Integer
End Type

Private Type DevMode
    dmDeviceName As String * CCHDEVICENAME
    dmSpecVersion As Integer
    dmDriverVersion As Integer
    dmSize As Integer
    dmDriverExtra As Integer
    dmFields As Long
    dmOrientation As Integer
    dmPaperSize As Integer
    dmPaperLength As Integer
    dmPaperWidth As Integer
    dmScale As Integer
    dmCopies As Integer
    dmDefaultSource As Integer
    dmPrintQuality As Integer
    dmColor As Integer
    dmDuplex As Integer
    dmYResolution As Integer
    dmTTOption As Integer
    dmCollate As Integer
    dmFormName As String * CCHFORMNAME
    dmUnusedPadding As Integer
    dmBitsPerPel As Integer
    dmPelsWidth As Long
    dmPelsHeight As Long
    dmDisplayFlags As Long
    dmDisplayFrequency As Long
End Type

Private Type LogFont
    lfHeight As Long
    lfWidth As Long
    lfEscapement As Long
    lfOrientation As Long
    lfWeight As Long
    lfItalic As Byte
    lfUnderline As Byte
    lfStrikeOut As Byte
    lfCharSet As Byte
    lfOutPrecision As Byte
    lfClipPrecision As Byte
    lfQuality As Byte
    lfPitchAndFamily As Byte
    lfFaceName(LF_FACESIZE) As Byte
End Type

Private Type ChooseFont
    lStructSize As Long
    hwndOwner As Long
    hDC As Long
    lpLogFont As Long
    iPointSize As Long
    fFlags As Long
    rgbColors As Long
    lCustData As Long
    lpfnHook As Long
    lpTemplateName As String
    hInstance As Long
    lpszStyle As String
    nFontType As Integer
    MISSING_ALIGNMENT As Integer
    nSizeMin As Long
    nSizeMax As Long
End Type
      
Private Type ChooseColor
    lStructSize As Long
    hwndOwner As Long
    hInstance As Long
    rgbResult As Long
    lpCustColors As Long
    ccFlags As Long
    lCustData As Long
    lpfnHook As Long
    lpTemplateName As String
End Type

Private Type OpenFileName
    lStructSize As Long
    hwndOnwer As Long
    hInstance As Long
    lpstrFilter As String
    lpstrCustomFilter As Long
    nMaxCustFilter As Long
    nFilterIndex As Long
    lpstrFile As String
    nMaxFile As Long
    lpstrFileTitle As Long
    nMaxFileTitle As Long
    lpstrInitialDir As String
    lpstrTitle As String
    nFlags As Long
    nFileOffset As Integer
    nFileExtension As Integer
    lpstrDefExt As Long
    lCustData As Long
    lpfnHook As Long
    lpTemplateName As Long
End Type

Public Enum ComDlgActions
    cdlShowOpen = 1
    cdlShowSave = 2
    cdlShowColor = 3
    cdlShowFont = 4
    cdlShowPrinter = 5
    cdlShowHelp = 6
End Enum

Public Enum dlgFlags
    cdlPDNoChangeDir = &H8
    cdlPDShowhelp = &H10
    cdlPDAllowMultiselect = &H200
    cdlPDPathMustExist = &H800
    cdlPDFileMustExist = &H1000
    cdlPDNoNetworkButton = &H20000
    cdlPDNoLongNames = &H40000
    cdlPDLongNames = &H200000
    cdlPDHideReadOnly = &H4
    cdlPDExplorer = &H80000
    cdlCCRGBInit = &H1
    cdlCCFullOpen = &H2
    cdlCCAnyColor = &H100
    cdlPDDisablePrintToFile = &H80000
    cdlPDReturnDC = &H100
    cdlPDReturnIC = &H200
    cdlPDAllPages = &H0
    cdlPDPrintSetup = &H40
    cdlCFEffects = &H100&
    cdlCFScreenFonts = &H1
    cdlCFPrinterFonts = &H2
    cdlCFBoth = &H3
End Enum

Public Enum dlgOrientation
    cdlLandscape = 0
    cdlPortrait = 1
End Enum

Public Enum dlgHelpCommands
    cdlHelpCommand = &H102&
    cdlHelpContents = &H3&
    cdlHelpContentsHW4X = &HB
    cdlHelpContext = &H1&
    cdlHelpContextPopup = &H8&
    cdlHelpForceFile = &H9&
    cdlHelpHelpOnHelp = &H4&
    cdlHelpIndex = &H3&
    cdlHelpKey = &H101&
    cdlHelpPartialKey = &H105&
    cdlHelpQuit = &H2&
    cdlHelpSetContents = &H5&
    cdlHelpSetIndex = &H5&
    cdlHelpSearch = 261
End Enum

Public Orientation As dlgOrientation
Public Filter As String
Public Filename As String
Public FileTitle As String
Public Color As Long
Public CancelError As Boolean
Public DialogTitle As String
Public DefaultExt As String
Public InitDir As String
Public Tag As String
Public FontName As String
Public Flags As dlgFlags
Public FilterIndex As Long
Public HelpFile As String
Public HelpCommand As dlgHelpCommands
Public MaxFileSize As Integer
Public Copies As Integer
Public FromPage As Integer
Public ToPage As Integer
Public Min As Integer
Public Max As Integer
Public DeviceName As String
Public FontBold As Boolean
Public FontItalic As Boolean
Public FontSize As Integer
Public FontUnderLine As Boolean
Public FontStrikeThru As Boolean
Public PrinterDefault As Boolean

'-----------------------------------------------------------
' Windows API-Deklarationen (ComDlg32)
'-----------------------------------------------------------
Private Declare Function GetOpenFileName Lib "comdlg32.dll" Alias "GetOpenFileNameA" (pOpenFileName As OpenFileName) As Long
Private Declare Function GetSaveFileName Lib "comdlg32.dll" Alias "GetSaveFileNameA" (pOpenFileName As OpenFileName) As Long
Private Declare Function ChooseFontDlg Lib "comdlg32.dll" Alias "ChooseFontA" (pChoosefont As ChooseFont) As Long
Private Declare Function ChooseColorDlg Lib "comdlg32.dll" Alias "ChooseColorA" (pChoosecolor As ChooseColor) As Long
Private Declare Function CommDlgExtendedError Lib "comdlg32.dll" () As Long
Private Declare Function PrintDlg Lib "comdlg32.dll" Alias "PrintDlgA" (pPrintdlg As PrintDlg) As Long

'-----------------------------------------------------------
' Windows API-Deklarationen (User32)
'-----------------------------------------------------------
Private Declare Function WinHelp Lib "user32.dll" Alias "WinHelpA" (ByVal hwnd As Long, ByVal lpHelpFile As String, ByVal wCommand As Long, ByVal dwData As Long) As Long
Private Declare Function GetActiveWindow Lib "user32.dll" () As Long
Private Declare Function GetDC Lib "user32.dll" (ByVal hwnd As Long) As Long

'-----------------------------------------------------------
' Windows API-Deklarationen (Kernel32)
'-----------------------------------------------------------
Private Declare Function GlobalAlloc Lib "kernel32" (ByVal wFlags As Long, ByVal dwBytes As Long) As Long
Private Declare Function GlobalUnlock Lib "kernel32" (ByVal hMem As Long) As Long
Private Declare Function GlobalLock Lib "kernel32" (ByVal hMem As Long) As Long
Private Declare Function GlobalFree Lib "kernel32" (ByVal hMem As Long) As Long
Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (Destination As Any, Source As Any, ByVal Length As Long)

'-----------------------------------------------------------
' Windows API-Deklarationen (GDI32)
'-----------------------------------------------------------
Private Declare Function DeleteDC Lib "gdi32" (ByVal hDC As Long) As Long
Private Declare Function GetDeviceCaps Lib "gdi32" (ByVal hDC As Long, ByVal nIndex As Long) As Long

'-----------------------------------------------------------
' SUB: ShowFont
'
' Zeigt den Schrift-Auswahl Dialog an
'-----------------------------------------------------------
Public Sub ShowFont()
    
    Dim ChFont As ChooseFont
    Dim LFont As LogFont
    Dim Address As Long
    Dim Memhandle As Long
    Dim FaceNameString As String
    Dim Result As Long
 
    ChFont.lpLogFont = VarPtr(LFont)
    ChFont.hDC = GetDC(GetActiveWindow)
    ChFont.lStructSize = Len(ChFont)
    ChFont.hwndOwner = GetActiveWindow
    ChFont.fFlags = Flags
    ChFont.nFontType = SCREEN_FONTTYPE
    ChFont.rgbColors = Color
    Result = ChooseFontDlg(ChFont)
 
    If Result <> 0 Then
        FaceNameString = StrConv(LFont.lfFaceName, vbUnicode)
        Me.FontSize = Abs(LFont.lfHeight * (72 / GetDeviceCaps(GetDC(GetActiveWindow), LOGPIXELSY)))
        Me.FontName = Left$(FaceNameString, InStr(FaceNameString, Chr$(0)) - 1)
        If Asc(LFont.lfItalic) = 49 Then Me.FontItalic = True Else Me.FontItalic = False
        If Asc(LFont.lfStrikeOut) = 49 Then Me.FontStrikeThru = True Else Me.FontStrikeThru = False
        If Asc(LFont.lfUnderline) = 49 Then Me.FontUnderLine = True Else Me.FontUnderLine = False
        If Asc(LFont.lfWeight) = 55 Then Me.FontBold = True Else Me.FontBold = False
        Color = ChFont.rgbColors
    Else
        If CancelError = True Then
            Err.Raise 32755, "ShowFont", "Abbrechen wurde gewhlt"
        End If
    End If
    
    If LFont.lfWeight < 500 Then Me.FontBold = False Else Me.FontBold = True

End Sub

'-----------------------------------------------------------
' SUB: ShowPrinter
'
' Zeigt den Drucken Dialog an
'-----------------------------------------------------------

Public Sub ShowPrinter()
    
    Dim Address As Long
    Dim P As PrintDlg, Ok As Long
    Dim D As DevMode, Result As Long
    Dim Memhandle As Long, wSize As Long
 
    P.lStructSize = Len(P)
    P.hwndOwner = GetActiveWindow
    P.pFlags = Flags
    P.nCopies = Copies
    P.nToPage = ToPage
    P.nFromPage = FromPage
    P.nMaxPage = Max
    P.nMinPage = Min
    D.dmDeviceName = Me.DeviceName
    D.dmOrientation = Orientation
    Result = PrintDlg(P)
    GetLastComDlg32Error
    
    If Result <> 0 Then
        Address = GlobalLock(P.hDevMode)
        Call CopyMemory(D, ByVal Address, Len(D))
        If P.hDC <> 0 Then Ok = DeleteDC(P.hDC)
        If P.hDevNames <> 0 Then Ok = GlobalFree(P.hDevNames)
        Ok = GlobalUnlock(P.hDevMode)
        Ok = GlobalFree(P.hDevMode)
        Me.DeviceName = Left$(D.dmDeviceName, InStr(D.dmDeviceName, Chr$(0)) - 1)
        Orientation = D.dmOrientation
        Copies = P.nCopies
        FromPage = P.nFromPage
        ToPage = P.nToPage
        If Me.PrinterDefault = True Then
            Dim Pr As Object
            For Each Pr In Printers
                If Pr.DeviceName = Me.DeviceName Then Set Printer = Pr
            Next Pr
        End If
    Else
        If CancelError = True Then
            Err.Raise 32755, "CommonDialog::ShowColor", "Abbrechen wurde gewhlt"
        End If
    End If
    
End Sub

'-----------------------------------------------------------
' SUB: ShowColor
'
' Zeigt den Farb-Auswahl Dialog an
'-----------------------------------------------------------
Public Sub ShowColor()
    
    Dim cc As ChooseColor
    Dim hMem As Long
    Dim pMem As Long
    Dim custcols(0 To 15) As Long
    Dim C As Integer
    Dim RetVal As Long
 
    For C = 0 To 15
        custcols(C) = QBColor(15)
    Next C
 
    hMem = GlobalAlloc(GMEM_MOVEABLE Or GMEM_ZEROINIT, 64)
    pMem = GlobalLock(hMem)
    CopyMemory ByVal pMem, custcols(0), 64
    cc.lStructSize = Len(cc)
    cc.hwndOwner = GetActiveWindow
    cc.hInstance = 0
    cc.rgbResult = Color
    cc.lpCustColors = pMem
    cc.ccFlags = Flags
    cc.lCustData = 0
    cc.lpfnHook = 0
    cc.lpTemplateName = ""
    RetVal = ChooseColorDlg(cc)
    GetLastComDlg32Error
    
    If RetVal <> 0 Then
        
        CopyMemory custcols(0), ByVal pMem, 64
        Color = cc.rgbResult
    
    Else
        
        If CancelError = True Then
            Err.Raise 32755, "CommonDialog::ShowColor", "Abbrechen wurde gewhlt"
        End If
    
    End If
    
    RetVal = GlobalUnlock(hMem)
    RetVal = GlobalFree(pMem)

End Sub

'-----------------------------------------------------------
' SUB: ShowHelp
'
' Zeigt eine Windows-Hilfedatei an
'-----------------------------------------------------------
Public Sub ShowHelp()
    Dim Ret As Long
    If Me.HelpCommand = 0 Then Me.HelpCommand = cdlHelpContents
    If Me.HelpFile = "" Then Me.HelpFile = App.HelpFile
    Ret& = WinHelp(GetActiveWindow, Me.HelpFile, Me.HelpCommand, 0)
End Sub

'-----------------------------------------------------------
' FUNCTION: ShowOpen
'
' Zeigt den ffnen Dialog an
'-----------------------------------------------------------
Public Function ShowOpen(Optional verzeichnis) As String
    Dim pOpenFileName As OpenFileName
    Dim FileN As String, D As Integer
    Dim l As Long
 
    Filename = Me.Filename + Chr(0) + Space(MAX_PATH)
    
    If IsMissing(Filter) Then
        Filter = "Alle Dateien (*.*)|*.*"
    End If
 
    If Not IsMissing(verzeichnis) Then InitDir = verzeichnis
 
    If InitDir = "" Then
        InitDir = CurDir
    End If
 
    If Right$(Filter, 1) <> "|" Then Filter = Filter & "|"
    For l = 1 To Len(Filter)
        If Mid$(Filter, l, 1) = "|" Then Mid$(Filter, l, 1) = Chr(0)
    Next l
 
    Filter = Filter & Chr(0) & Chr(0)
    With pOpenFileName
        .lStructSize = Len(pOpenFileName)
        .hwndOnwer = GetActiveWindow
        .lpstrFile = Filename
        .nMaxFile = MAX_PATH
        .lpstrFilter = Filter
        .nFilterIndex = FilterIndex
        .nMaxFile = Me.MaxFileSize
        If Not IsMissing(DialogTitle) Then
            .lpstrTitle = DialogTitle
        End If
        .lpstrInitialDir = InitDir
        .nFlags = Flags
    End With
 
    If GetOpenFileName(pOpenFileName) <> 0 Then
        GetLastComDlg32Error
        ShowOpen = Left$(pOpenFileName.lpstrFile, InStr(pOpenFileName.lpstrFile, Chr(0)) - 1)
        Me.Filename = Left$(pOpenFileName.lpstrFile, InStr(pOpenFileName.lpstrFile, Chr(0)) - 1)
        D% = InStrRev(Me.Filename, "\")
        Me.FileTitle = Right$(Me.Filename, Len(Me.Filename) - D%)
        Me.FilterIndex = pOpenFileName.nFilterIndex
        Me.MaxFileSize = pOpenFileName.nMaxFile
    Else
        GetLastComDlg32Error
        ShowOpen = ""
        Me.Filename = ""
        If CancelError = True Then
            Err.Raise 32755, "CommonDialog::ShowOpen", "Abbrechen wurde gewhlt"
        End If
    End If

End Function

'-----------------------------------------------------------
' FUNCTION: ShowSave
'
' Zeigt den Speichern Dialog an
'-----------------------------------------------------------
Public Function ShowSave(Optional verzeichnis) As String
    
    Dim pOpenFileName As OpenFileName
    Dim FileN As String, D As Integer
    Dim l As Long, Extension As String
 
    Filename = Me.Filename + Chr(0) + Space(MAX_PATH)
    If IsMissing(Filter) Then
        Filter = "Alle Dateien (*.*)|*.*"
    End If
    
    If Not IsMissing(verzeichnis) Then InitDir = verzeichnis
            
    If InitDir = "" Then
        InitDir = CurDir
    End If
 
    If Right$(Filter, 1) <> "|" Then Filter = Filter & "|"
    For l = 1 To Len(Filter)
        If Mid$(Filter, l, 1) = "|" Then Mid$(Filter, l, 1) = Chr(0)
    Next l
 
    Filter = Filter & Chr(0) & Chr(0)
    With pOpenFileName
        .lStructSize = Len(pOpenFileName)
        .hwndOnwer = GetActiveWindow
        .lpstrFile = Filename
        .nMaxFile = MAX_PATH
        .nFilterIndex = FilterIndex
        .lpstrFilter = Filter
        .lpstrInitialDir = InitDir
        .nMaxFile = Me.MaxFileSize
        .nFlags = Flags
    End With
 
    If GetSaveFileName(pOpenFileName) <> 0 Then
        GetLastComDlg32Error
        ShowSave = Left$(pOpenFileName.lpstrFile, InStr(pOpenFileName.lpstrFile, Chr(0)) - 1)
        Me.Filename = Left$(pOpenFileName.lpstrFile, InStr(pOpenFileName.lpstrFile, Chr(0)) - 1)
        D% = InStrRev(Me.Filename, "\")
        Me.FileTitle = Right$(Me.Filename, Len(Me.Filename) - D%)
        Me.FilterIndex = pOpenFileName.nFilterIndex
        Me.MaxFileSize = pOpenFileName.nMaxFile
    Else
        GetLastComDlg32Error
        ShowSave = ""
        Me.Filename = ""
        If CancelError = True Then
            Err.Raise 32755, "CommonDialog::ShowSave", "Abbrechen wurde gewhlt"
        End If
    End If
    Extension = Trim$(GetParam(Filter, 2 * FilterIndex, Chr(0)))
    Extension = Right$(Extension, (Len(Extension) - InStrRev(Extension, ".")) + 1)
    
    If Len(Filename) <= 3 Then
        Filename = Filename & Extension
    End If
    
    If Filename <> "" Then
        If Not Mid$(Filename, Len(Filename) - 3, 1) = "." Then
            Filename = Filename & Extension
        End If
        If Not DefaultExt = "" Then
            If Not Left$(DefaultExt, 1) = "." Then
                DefaultExt = "." + DefaultExt
            End If
            If Not Right$(Filename, Len(DefaultExt)) = DefaultExt Then
                ShowSave = ShowSave + DefaultExt
                Me.Filename = Me.Filename + DefaultExt
            End If
        End If
    End If
    
End Function

'-----------------------------------------------------------
' SUB: About
'
' Zeigt den About-Dialog an
'-----------------------------------------------------------
Public Sub About()
    MsgBox "VB-CommonDialog 6.0 Replacement " & Chr(13) & "(C) 1999-2003 by Christoph von Wittich" & Chr(13), 64, "ComDlg32"
End Sub

'-----------------------------------------------------------
' PROPERTY LET: Action
'
' Zeigt einen Dialog an (muss als Parameter bergeben werden)
'-----------------------------------------------------------
Property Let Action(cdlPDAction As ComDlgActions)
    Select Case cdlPDAction
        Case 1
            ShowOpen
        Case 2
            ShowSave
        Case 3
            ShowColor
        Case 4
            ShowFont
        Case 5
            ShowPrinter
        Case 6
            ShowHelp
    End Select
End Property

'-----------------------------------------------------------
' SUB: GetLastComDlg32Error
'
' Gibt eine genaue Fehlerbeschreibung zurck
'-----------------------------------------------------------
Private Sub GetLastComDlg32Error()
    
    Dim cErrNumber As Long
    Dim cErrDescription As String
    
    cErrNumber& = CommDlgExtendedError()
    
    Select Case cErrNumber
        Case &H0
            cErrDescription$ = "The error involved a general common dialog box property."
        Case &H1
            cErrDescription$ = "The function was provided with an invalid structure size."
        Case &H2
            cErrDescription$ = "The function failed during initialization (probably insufficient memory)."
        Case &H3
            cErrDescription$ = "The function was not provided with a valid template (if one was required)."
        Case &H4
            cErrDescription$ = "The function was not provided with a valid instance handle (if one was required)."
        Case &H5
            cErrDescription$ = "The function failed to load the desired string."
        Case &H6
            cErrDescription$ = "The function failed to find the desired resource."
        Case &H7
            cErrDescription$ = "The function failed to load the desired resource."
        Case &H8
            cErrDescription$ = "The function failed to lock the desired resource."
        Case &H9
            cErrDescription$ = "The function failed to allocate sufficient memory."
        Case &HA
            cErrDescription$ = "The function failed to lock the desired memory."
        Case &HB
            cErrDescription$ = "The function was not provided with a valid hook function handle (if one was required)."
        Case &HC
            cErrDescription$ = "The function failed to successfully register a window message."
        Case &H1000
            cErrDescription$ = "The error involved the Print common dialog box."
        Case &H1001
            cErrDescription$ = "The function failed to load the desired resources."
        Case &H1002
            cErrDescription$ = "The function failed to parse the printer-related strings in WIN.INI."
        Case &H1003
            cErrDescription$ = "The handles to the data structures provided were nonzero even though the function was asked to return information about the default printer."
        Case &H1004
            cErrDescription$ = "The function failed to load the desired device driver."
        Case &H1005
            cErrDescription$ = "The printer driver failed to initialize the DEVMODE structure."
        Case &H1006
            cErrDescription$ = "The function failed during initialization."
        Case &H1007
            cErrDescription$ = "The function could not find any printers."
        Case &H1008
            cErrDescription$ = "The function could not find a default printer."
        Case &H1009
            cErrDescription$ = "The data in the two data structures describe different printers (i.e., they hold conflicting information)."
        Case &H100A
            cErrDescription$ = "The function failed to create an information context."
        Case &H100B
            cErrDescription$ = "The function could not find information in WIN.INI about the requested printer."
        Case &H100C
            cErrDescription$ = "The function was told that the information provided described the default printer, but the default printer's actual settings were different."
        Case &H2000
            cErrDescription$ = "The error involved the Choose Font common dialog box."
        Case &H2001
            cErrDescription$ = "The function could not find any existing fonts."
        Case &H2002
            cErrDescription$ = "The function was provided with a maximum font size value smaller than the provided minimum font size."
        Case &H3000
            cErrDescription$ = "The error involved the Open File or Save File common dialog box."
        Case &H3001
            cErrDescription$ = "The function had insufficient memory to subclass the list box."
        Case &H3002
            cErrDescription$ = "The function was provided with or received an invalid filename."
        Case &H3003
            cErrDescription$ = "The function was provided with a filename buffer which was too small."
        Case &H4000
            cErrDescription$ = "The error involved the Find or Replace common dialog box."
        Case &H4001
            cErrDescription$ = "The function was provided with an invalid buffer."
        Case &HFFFF
            cErrDescription$ = "The function could not open the dialog box."
    End Select
    
    If cErrNumber <> 0 Then Err.Raise cErrNumber, "VB-CommonDialog 6.0", cErrDescription

End Sub

'-----------------------------------------------------------
' FUNCTION: GetParam
'
' Gibt einen Parameter/Wort eines Strings zurck
'-----------------------------------------------------------
Private Function GetParam(CmdLine As String, CmdNumber As Integer, Seperator As String) As String
    Dim strStart As Integer
    Dim Param As Integer
    Dim SepPos As Integer, SepPos2 As Integer
    Dim PTmp As String
    strStart = 1
    If Not Left$(CmdLine, Len(Seperator)) = Seperator Then CmdLine = Seperator & CmdLine
    Do Until CmdNumber = Param
        Param = Param + 1
        SepPos = InStr(strStart, CmdLine, Seperator)
        SepPos2 = InStr(SepPos + 1, CmdLine, Seperator)
        If SepPos2 = 0 Then SepPos2 = Len(CmdLine)
        PTmp = Mid$(CmdLine, SepPos + 1, SepPos2 - SepPos - 1)
        strStart = SepPos2
    Loop
    GetParam = PTmp
End Function

'-----------------------------------------------------------
' SUB: Class_Initialize
'
' Initialisierung der Klasse
' und festlegen der Standard Werte
'-----------------------------------------------------------

Private Sub Class_Initialize()
    
    'Do not change (Windows DefaultValues)!
    Me.MaxFileSize = 256
    Me.Copies = 1
    Me.FromPage = 1
    Me.ToPage = 1
    Me.Min = 1
    Me.Max = 1
    Me.FontSize = 10

End Sub
