VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "TextFile"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'****************************************************
'* TextFile.cls                                     *
'* class representing a data text file              *
'* Programmed: Konrad Rudolph (Mad Rat Pro.)        *
'* Last Change: 01.02.2004 19:29                    *
'* Version: 1.0.0                                   *
'****************************************************
Option Explicit

'----------------------------------------------------
' private members
'----------------------------------------------------

Private m_Data() As String
'----------------------------------------------------

'----------------------------------------------------
' Read
' reads the values of a file into the RAM
' - [IN] Day As Date: day of which the values are to be read
' - returns success
'----------------------------------------------------
Friend Function Read(Basepath As String, Day As Date) As Boolean
    Dim AppPath As String   ' application path
    Dim File    As String   ' file name
    Dim Content As String   ' file content
    Dim ff      As Long     ' file channel handle
    
    On Error GoTo ERR_Read
    
    ' adjust application path
    
    AppPath = App.Path
    
    If Right$(AppPath, 1) <> "\" Then _
        AppPath = AppPath & "\"
    
    ' create file name from date
    
    File = Basepath & DatePart("yyyy", Day) & _
           Format$(DatePart("m", Day), "00") & _
           Format$(DatePart("d", Day), "00") & ".txt"
    
    ' open file, read data and close
    
    If Not FileExists(File) Then _
        Exit Function
    
    ff = FreeFile()
    Open File For Binary As #ff
    Content = Space$(LOF(ff))
    Get #ff, , Content
    Close #ff
    
    ' split up into an array of lines
    
    m_Data = Split(Content, vbNewLine)
    
    Read = True
    
    On Error GoTo 0
    Exit Function

ERR_Read:
    On Error GoTo 0
End Function

'----------------------------------------------------
' Values As Long()
' read-only
' - returns the values from the current file
' non-existing values are filled with "-1"
' we presume a non-faulty entry data!
'----------------------------------------------------
Friend Property Get Values() As Long()
    Dim Dates(QUARTS_PER_DAY - 1) As Long   ' all the values on one day, including missing ones
    Dim TimeValue() As String               ' time-value pair of current line
    Dim I As Long                           ' counter
    
    ' init array with invalid values
    
    For I = 0 To QUARTS_PER_DAY - 1
        Dates(I) = -1&
    Next I
    
    For I = 2 To UBound(m_Data)
        ' split time-value pair
        
        TimeValue = Split(m_Data(I))
        
        ' assign value: get index from date and fill in
        ' table cell with corresponding value
        
        Dates(GetIndexFromTime(CDate(TimeValue(0)))) = CLng(TimeValue(1))
    Next I
    
    Values = Dates
End Property
