VERSION 5.00
Begin VB.Form DlgMain 
   Caption         =   "Diagram Example"
   ClientHeight    =   6165
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   10170
   LinkTopic       =   "Form1"
   ScaleHeight     =   6165
   ScaleWidth      =   10170
   StartUpPosition =   3  'Windows-Standard
   Begin VB.CommandButton CmdVariance 
      Caption         =   "Show Variance"
      Height          =   435
      Left            =   8640
      TabIndex        =   6
      Top             =   4200
      Width           =   1455
   End
   Begin VB.TextBox TxtDate 
      Height          =   315
      Left            =   6900
      TabIndex        =   4
      Top             =   4260
      Width           =   1635
   End
   Begin VB.CommandButton CmdCustom 
      Caption         =   "Custom Date"
      Height          =   435
      Left            =   3180
      TabIndex        =   3
      Top             =   4200
      Width           =   1455
   End
   Begin VB.CommandButton CmdMissing 
      Caption         =   "Missing Values"
      Height          =   435
      Left            =   1620
      TabIndex        =   2
      Top             =   4200
      Width           =   1455
   End
   Begin VB.CommandButton CmdDraw 
      Caption         =   "Draw Values"
      Height          =   435
      Left            =   60
      TabIndex        =   1
      Top             =   4200
      Width           =   1455
   End
   Begin VB.PictureBox PicDiagram 
      Height          =   3135
      Left            =   60
      ScaleHeight     =   3075
      ScaleWidth      =   6135
      TabIndex        =   0
      Top             =   60
      Width           =   6195
   End
   Begin VB.Label LblDate 
      Caption         =   "Date (leave empty for ""now""):"
      Height          =   195
      Left            =   4740
      TabIndex        =   5
      Top             =   4320
      Width           =   2175
   End
End
Attribute VB_Name = "DlgMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private m_Diag As Diagram
'----------------------------------------------------

Private Sub Form_Load()
    Set m_Diag = New Diagram
    
    ' use some fancy settings to demonstrate the flexibility of the class
    
    m_Diag.BackColor = vbBlack
    m_Diag.GridColor = &H408000
    m_Diag.GridStyle = vbDot
    m_Diag.TextColor = &H407040
    m_Diag.LineColor = vbGreen
    m_Diag.HighlightColor = vbYellow
    m_Diag.VarianceColor = vbCyan
    
    m_Diag.Font.Name = "Tahoma"
    m_Diag.Font.Size = 10
    
    m_Diag.ScaleY = 10
    m_Diag.UseHighlight = True
    
    Set m_Diag.Target = PicDiagram
    
    ' init controls
    
    TxtDate.Text = CStr(Now)
End Sub

Private Sub CmdDraw_Click()
    ' create the diagram
    Call m_Diag.Create(EndDate:=#1/2/2004 5:04:32 AM#)
End Sub

Private Sub CmdMissing_Click()
    ' create the diagram ... example with missing values
    Call m_Diag.Create(EndDate:=#1/6/2004 5:04:32 AM#)
End Sub

Private Sub CmdCustom_Click()
    Dim Success As Boolean
    
    ' create a custom diagram
    
    If TxtDate.Text <> "" Then _
        Success = m_Diag.Create(CDate(TxtDate.Text)) _
    Else _
        Success = m_Diag.Create
    
    ' demonstrate error handling
    
    If Not Success Then _
        Call MsgBox("No data available for chosen date!", vbCritical, "Error")
End Sub

Private Sub CmdVariance_Click()
    ' show variance graph
    Call m_Diag.Variance
End Sub

Private Sub Form_Resize()
    On Error Resume Next
    
    ' align controls & match the picturebox's size to the window size
    
    Call CmdDraw.Move(CmdDraw.Left, Me.ScaleHeight - CmdDraw.Height - CmdDraw.Left)
    
    Call CmdMissing.Move(CmdMissing.Left, CmdDraw.Top)
    
    Call CmdCustom.Move(CmdCustom.Left, CmdDraw.Top)
    
    Call LblDate.Move(LblDate.Left, CmdDraw.Top + 7 * Screen.TwipsPerPixelY)
    
    Call TxtDate.Move(TxtDate.Left, CmdDraw.Top + 4 * Screen.TwipsPerPixelY)
    
    Call CmdVariance.Move(CmdVariance.Left, CmdDraw.Top)
    
    With PicDiagram
        Call .Move( _
            .Left, _
            .Top, _
            Me.ScaleWidth - .Left * 2, _
            CmdDraw.Top - .Top * 2 _
        )
    End With
    
    On Error GoTo 0
End Sub
